DefinitionBlock ("DSDT.aml", "DSDT", 2, "_ASUS_", "Notebook", 0x00000000)
{
    Name (SP1O, 0x2E)
    Name (IO1B, 0x0290)
    Name (IO1L, 0x20)
    Name (IO2B, 0x0230)
    Name (IO2L, 0x20)
    Name (IO3B, 0x0F40)
    Name (IO3L, 0x20)
    Name (SMBB, 0x0B20)
    Name (SMBL, 0x20)
    Name (SMB0, 0x0B00)
    Name (SMBM, 0x10)
    Name (PMBS, 0x0800)
    Name (PMLN, 0xA0)
    Name (SMIO, 0xB2)
    Name (GPBS, Zero)
    Name (GPLN, Zero)
    Name (APCB, 0xFEC00000)
    Name (APCL, 0x1000)
    Name (SPIB, 0xFEC10000)
    Name (SPIL, 0x1000)
    Name (HPTB, 0xFED00000)
    Name (HPTL, 0x1000)
    Name (GIOB, 0xFED80100)
    Name (IOMB, 0xFED80D00)
    Name (SMIB, 0xFED80200)
    Name (ACPH, 0xDE)
    Name (ASSB, Zero)
    Name (AOTB, Zero)
    Name (AAXB, Zero)
    Name (SHPC, Zero)
    Name (PEPM, One)
    Name (PEER, One)
    Name (PECS, One)
    Name (ITKE, Zero)
    Name (MBEC, 0xFFFF)
    Name (AMWV, 0x09)
    Name (PEBS, 0xE0000000)
    Name (PEBL, 0x10000000)
    Name (SMIP, 0xB2)
    Name (PEHP, Zero)
    Name (PICM, Zero)
    Method (_PIC, 1, NotSerialized)
    {
        If (Arg0)
        {
            Store (0xAA, DBG8)
            \_SB.IRQC ()
        }
        Else
        {
            Store (0xAC, DBG8)
        }
        Store (Arg0, PICM)
    }
    Name (OSVR, Ones)
    Method (OSFL, 0, NotSerialized)
    {
        If (LNotEqual (OSVR, Ones))
        {
            Return (OSVR)
        }
        If (LEqual (PICM, Zero))
        {
            Store (0xAC, DBG8)
        }
        Store (One, OSVR)
        If (CondRefOf (_OSI, Local0))
        {
            If (_OSI ("Linux"))
            {
                Store (0x03, OSVR)
            }
            If (_OSI ("Windows 2001"))
            {
                Store (0x04, OSVR)
            }
            If (_OSI ("Windows 2001.1"))
            {
                Store (0x05, OSVR)
            }
            If (_OSI ("FreeBSD"))
            {
                Store (0x06, OSVR)
            }
            If (_OSI ("HP-UX"))
            {
                Store (0x07, OSVR)
            }
            If (_OSI ("OpenVMS"))
            {
                Store (0x08, OSVR)
            }
            If (_OSI ("Windows 2001 SP1"))
            {
                Store (0x09, OSVR)
            }
            If (_OSI ("Windows 2001 SP2"))
            {
                Store (0x0A, OSVR)
            }
            If (_OSI ("Windows 2001 SP3"))
            {
                Store (0x0B, OSVR)
            }
            If (_OSI ("Windows 2006"))
            {
                Store (0x0C, OSVR)
            }
            If (_OSI ("Windows 2006 SP1"))
            {
                Store (0x0D, OSVR)
            }
            If (_OSI ("Windows 2009"))
            {
                Store (0x0E, OSVR)
            }
        }
        Else
        {
            If (MCTH (_OS, "Microsoft Windows NT"))
            {
                Store (Zero, OSVR)
            }
            If (MCTH (_OS, "Microsoft Windows"))
            {
                Store (One, OSVR)
            }
            If (MCTH (_OS, "Microsoft WindowsME: Millennium Edition"))
            {
                Store (0x02, OSVR)
            }
            If (MCTH (_OS, "Linux"))
            {
                Store (0x03, OSVR)
            }
            If (MCTH (_OS, "FreeBSD"))
            {
                Store (0x06, OSVR)
            }
            If (MCTH (_OS, "HP-UX"))
            {
                Store (0x07, OSVR)
            }
            If (MCTH (_OS, "OpenVMS"))
            {
                Store (0x08, OSVR)
            }
        }
        Return (OSVR)
    }
    Method (MCTH, 2, NotSerialized)
    {
        If (LLess (SizeOf (Arg0), SizeOf (Arg1)))
        {
            Return (Zero)
        }
        Add (SizeOf (Arg0), One, Local0)
        Name (BUF0, Buffer (Local0) {})
        Name (BUF1, Buffer (Local0) {})
        Store (Arg0, BUF0)
        Store (Arg1, BUF1)
        While (Local0)
        {
            Decrement (Local0)
            If (LNotEqual (DerefOf (Index (BUF0, Local0)), DerefOf (Index (
                BUF1, Local0))))
            {
                Return (Zero)
            }
        }
        Return (One)
    }
    Name (PRWP, Package (0x02)
    {
        Zero, 
        Zero
    })
    Method (GPRW, 2, NotSerialized)
    {
        Store (Arg0, Index (PRWP, Zero))
        Store (ShiftLeft (SS1, One), Local0)
        Or (Local0, ShiftLeft (SS2, 0x02), Local0)
        Or (Local0, ShiftLeft (SS3, 0x03), Local0)
        Or (Local0, ShiftLeft (SS4, 0x04), Local0)
        If (And (ShiftLeft (One, Arg1), Local0))
        {
            Store (Arg1, Index (PRWP, One))
        }
        Else
        {
            ShiftRight (Local0, One, Local0)
            If (LOr (LEqual (OSFL (), One), LEqual (OSFL (), 0x02)))
            {
                FindSetLeftBit (Local0, Index (PRWP, One))
            }
            Else
            {
                FindSetRightBit (Local0, Index (PRWP, One))
            }
        }
        Return (PRWP)
    }
    Name (WAKP, Package (0x02)
    {
        Zero, 
        Zero
    })
    OperationRegion (DEB0, SystemIO, 0x80, One)
    Field (DEB0, ByteAcc, NoLock, Preserve)
    {
        DBG8,   8
    }
    OperationRegion (DEB1, SystemIO, 0x90, 0x02)
    Field (DEB1, WordAcc, NoLock, Preserve)
    {
        DBG9,   16
    }
    Name (SS1, One)
    Name (SS2, Zero)
    Name (SS3, One)
    Name (SS4, One)
    Name (IOST, 0x0000)
    Name (TOPM, 0x00000000)
    Name (ROMS, 0xFFE00000)
    Name (VGAF, One)
    Name (OSTY, Ones)
    OperationRegion (ACMS, SystemIO, 0x72, 0x10)
    Field (ACMS, ByteAcc, NoLock, Preserve)
    {
        ICMS,   8, 
        DCMS,   8, 
        Offset (0x0E), 
        P80,    8
    }
    IndexField (ICMS, DCMS, ByteAcc, NoLock, Preserve)
    {
        Offset (0x08), 
        BS_A,   32
    }
    OperationRegion (CFGS, SystemMemory, BS_A, 0x0100)
    Field (CFGS, AnyAcc, NoLock, Preserve)
    {
        Offset (0x0C), 
        PCIE,   32, 
        Offset (0x7F), 
            ,   5, 
        GGN2,   1, 
        Offset (0x87), 
        GECE,   1, 
        IR_E,   1, 
        Offset (0x93), 
            ,   5, 
        OSCF,   1, 
        Offset (0x9E), 
        PRS0,   1, 
        DET0,   1, 
        Offset (0xA2), 
        PRS1,   1, 
        DET1,   1, 
        Offset (0xA6), 
        PRS2,   1, 
        DET2,   1, 
        Offset (0xAA), 
        PRS3,   1, 
        DET3,   1, 
        Offset (0xB2), 
            ,   6, 
        ABPS,   1, 
            ,   3, 
        GPPS,   1
    }
    OperationRegion (CMPT, SystemIO, 0x0C50, 0x03)
    Field (CMPT, ByteAcc, NoLock, Preserve)
    {
        CMID,   8, 
            ,   6, 
        GPCT,   2, 
        GP0I,   1, 
        GP1I,   1, 
        GP2I,   1, 
        GP3I,   1, 
        GP4I,   1, 
        GP5I,   1, 
        GP6I,   1, 
        GP7I,   1
    }
    OperationRegion (PCFG, SystemMemory, PCIE, 0x02000000)
    Field (PCFG, AnyAcc, NoLock, Preserve)
    {
        Offset (0x20078), 
        Offset (0x2007A), 
        PMSA,   1, 
        Offset (0x28078), 
        Offset (0x2807A), 
        PMSB,   1, 
        Offset (0x48078), 
        Offset (0x4807A), 
        PMSC,   1, 
        Offset (0x8800A), 
        STCL,   16, 
        Offset (0xA0004), 
        SMIE,   1, 
        SMME,   1, 
        Offset (0xA0008), 
        RVID,   8, 
        Offset (0xA0014), 
        SMB1,   32, 
        Offset (0xA0082), 
            ,   2, 
        G31O,   1, 
        Offset (0xA00E1), 
            ,   6, 
        ACIR,   1, 
        Offset (0xA4004), 
        PCMD,   2, 
        Offset (0xA807A), 
        PMS0,   1, 
        Offset (0xA8088), 
        TLS0,   4, 
        Offset (0xA907A), 
        PMS1,   1, 
        Offset (0xA9088), 
        TLS1,   4, 
        Offset (0xAA07A), 
        PMS2,   1, 
        Offset (0xAA088), 
        TLS2,   4, 
        Offset (0xAB07A), 
        PMS3,   1, 
        Offset (0xAB088), 
        TLS3,   4
    }
    OperationRegion (PMIO, SystemIO, 0x0CD6, 0x02)
    Field (PMIO, ByteAcc, NoLock, Preserve)
    {
        INPM,   8, 
        DAPM,   8
    }
    IndexField (INPM, DAPM, ByteAcc, NoLock, Preserve)
    {
        Offset (0x24), 
        MMSO,   32, 
        Offset (0x60), 
        P1EB,   16
    }
    OperationRegion (ERMM, SystemMemory, MMSO, 0x1000)
    Field (ERMM, AnyAcc, NoLock, Preserve)
    {
        Offset (0x132), 
            ,   7, 
        GP51,   1, 
        Offset (0x136), 
            ,   7, 
        GP55,   1, 
        Offset (0x13A), 
            ,   7, 
        GP59,   1, 
        Offset (0x13D), 
        GP62,   8, 
        Offset (0x13F), 
            ,   7, 
        GP64,   1, 
        Offset (0x16A), 
            ,   7, 
        GE11,   1, 
            ,   7, 
        GE12,   1, 
        Offset (0x16E), 
            ,   7, 
        BATS,   1, 
        Offset (0x287), 
            ,   1, 
        CLPS,   1, 
        Offset (0x298), 
            ,   7, 
        G15A,   1, 
        Offset (0x2AF), 
            ,   2, 
        SLPS,   2, 
        Offset (0x376), 
        EPNM,   1, 
        DPPF,   1, 
        Offset (0x3BA), 
            ,   6, 
        PWDE,   1, 
        Offset (0x3BD), 
            ,   5, 
        ALLS,   1, 
        Offset (0x3EF), 
        PHYD,   1, 
            ,   1, 
            ,   1, 
        US5R,   1, 
        Offset (0x3F5), 
        GECD,   1
    }
    OperationRegion (ABIO, SystemIO, 0x0CD8, 0x08)
    Field (ABIO, DWordAcc, NoLock, Preserve)
    {
        INAB,   32, 
        DAAB,   32
    }
    Method (RDAB, 1, NotSerialized)
    {
        Store (Arg0, INAB)
        Return (DAAB)
    }
    Method (WTAB, 2, NotSerialized)
    {
        Store (Arg0, INAB)
        Store (Arg1, DAAB)
    }
    Method (RWAB, 3, NotSerialized)
    {
        And (RDAB (Arg0), Arg1, Local0)
        Or (Local0, Arg2, Local1)
        WTAB (Arg0, Local1)
    }
    Method (CABR, 3, NotSerialized)
    {
        ShiftLeft (Arg0, 0x05, Local0)
        Add (Local0, Arg1, Local1)
        ShiftLeft (Local1, 0x18, Local2)
        Add (Local2, Arg2, Local3)
        Return (Local3)
    }
    Method (GENC, 0, NotSerialized)
    {
        Store (Zero, Local0)
        While (LLess (Local0, 0x04))
        {
            Store (RDAB (CABR (0x03, Local0, 0xA4)), Local1)
            And (Local1, 0x0800, Local1)
            If (LNotEqual (Local1, Zero))
            {
                Return (0x0F)
            }
            Increment (Local0)
            Stall (0xC8)
        }
        Return (Zero)
    }
    Method (GHPS, 2, NotSerialized)
    {
        If (LEqual (Arg0, Zero))
        {
            If (LEqual (Arg1, Zero))
            {
                RWAB (CABR (0x06, Zero, 0xC0), 0xFFFFEFFF, Zero)
                RWAB (CABR (One, Zero, 0x65), 0xFFFFFEFE, Zero)
                Store (One, DET0)
            }
            If (LEqual (Arg1, 0x02))
            {
                RWAB (CABR (0x06, Zero, 0xC0), 0xFFFFBFFF, Zero)
                RWAB (CABR (One, Zero, 0x65), 0xFFFFFBFB, Zero)
                Store (One, DET2)
            }
            Stall (0xC8)
        }
        If (LEqual (Arg0, One))
        {
            RWAB (CABR (0x03, Arg1, 0xA2), 0xFFFDFFFF, 0x00020000)
            RWAB (CABR (0x03, Arg1, 0xA2), 0xFFFFFEFF, 0x0100)
            If (LEqual (Arg1, Zero))
            {
                RWAB (CABR (0x06, Zero, 0xC0), 0xFFFFEFFF, 0x1000)
                RWAB (CABR (One, Zero, 0x65), 0xFFFFFEFE, 0x0101)
                Store (Zero, DET0)
            }
            If (LEqual (Arg1, 0x02))
            {
                RWAB (CABR (0x06, Zero, 0xC0), 0xFFFFBFFF, 0x4000)
                RWAB (CABR (One, Zero, 0x65), 0xFFFFFBFB, 0x0404)
                Store (Zero, DET2)
            }
            RWAB (CABR (0x03, Arg1, 0xA2), 0xFFFDFFFF, Zero)
            Stall (0xC8)
        }
        If (GGN2)
        {
            If (LEqual (Arg0, Zero))
            {
                GEN2 ()
                Store (RDAB (CABR (0x03, 0x02, 0xA5)), Local0)
                And (Local0, 0xFF, Local0)
                Store (0x01F4, Local1)
                While (LAnd (LGreater (Local1, Zero), LNotEqual (Local0, 0x10)))
                {
                    Store (RDAB (CABR (0x03, 0x02, 0xA5)), Local0)
                    And (Local0, 0xFF, Local0)
                    Decrement (Local1)
                    Stall (0xC8)
                    Stall (0xC8)
                }
                If (LNotEqual (Local0, 0x10))
                {
                    GEN1 ()
                }
            }
            If (LEqual (GENC (), Zero))
            {
                RWAB (CABR (One, Zero, 0x40), 0xFFFFFFF7, 0x08)
            }
            Else
            {
                RWAB (CABR (One, Zero, 0x40), 0xFFFFFFF7, Zero)
            }
            Stall (0xC8)
        }
    }
    Method (GEN2, 0, NotSerialized)
    {
        Store (0x02, TLS2)
        RWAB (CABR (0x03, 0x02, 0xA4), 0xFFFFFFFE, One)
        RWAB (CABR (0x03, 0x02, 0xA2), 0xFFFFDFFF, 0x2000)
        RWAB (CABR (0x03, 0x02, 0xC0), 0xFFFF7FFF, 0x8000)
        RWAB (CABR (0x03, 0x02, 0xA4), 0xDFFFFFFF, 0x20000000)
        Stall (0xC8)
        Stall (0xC8)
    }
    Method (GEN1, 0, NotSerialized)
    {
        Store (One, TLS2)
        RWAB (CABR (0x03, 0x02, 0xA4), 0xFFFFFFFE, Zero)
        RWAB (CABR (0x03, 0x02, 0xA2), 0xFFFFDFFF, 0x2000)
        Stall (0xC8)
        Stall (0xC8)
    }
    OperationRegion (P1E0, SystemIO, P1EB, 0x04)
    Field (P1E0, ByteAcc, NoLock, Preserve)
    {
            ,   14, 
        PEWS,   1, 
        WSTA,   1, 
            ,   14, 
        PEWD,   1
    }
    Method (SPTS, 1, NotSerialized)
    {
        Store (One, PCMD)
        Store (Arg0, P80)
        CPMS ()
        CPMS ()
        Store (One, PEWS)
    }
    Method (SWAK, 1, NotSerialized)
    {
        CPMS ()
        CPMS ()
        Store (One, PEWS)
    }
    Method (TRMD, 1, NotSerialized)
    {
    }
    Method (CPMS, 0, NotSerialized)
    {
        If (LEqual (EPNM, Zero))
        {
            Store (One, PMSA)
            Store (One, PMSB)
            Store (One, PMSC)
            Store (One, PMS0)
            Store (One, PMS1)
            Store (One, PMS2)
            Store (One, PMS3)
        }
    }
    Scope (_GPE)
    {
    }
    Scope (_SB)
    {
        Name (PR00, Package (0x1A)
        {
            Package (0x04)
            {
                0x0014FFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0014FFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x0014FFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0014FFFF, 
                0x03, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x0012FFFF, 
                Zero, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0012FFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x0013FFFF, 
                Zero, 
                LNKE, 
                Zero
            }, 
            Package (0x04)
            {
                0x0013FFFF, 
                One, 
                LNKF, 
                Zero
            }, 
            Package (0x04)
            {
                0x0016FFFF, 
                Zero, 
                LNKG, 
                Zero
            }, 
            Package (0x04)
            {
                0x0016FFFF, 
                One, 
                LNKH, 
                Zero
            }, 
            Package (0x04)
            {
                0x0011FFFF, 
                Zero, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x0015FFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0015FFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x0015FFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0015FFFF, 
                0x03, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0002FFFF, 
                Zero, 
                LNKE, 
                Zero
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                Zero, 
                LNKE, 
                Zero
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                Zero, 
                LNKE, 
                Zero
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                Zero, 
                LNKF, 
                Zero
            }, 
            Package (0x04)
            {
                0x0007FFFF, 
                Zero, 
                LNKF, 
                Zero
            }, 
            Package (0x04)
            {
                0x0009FFFF, 
                Zero, 
                LNKF, 
                Zero
            }, 
            Package (0x04)
            {
                0x000AFFFF, 
                Zero, 
                LNKG, 
                Zero
            }, 
            Package (0x04)
            {
                0x000BFFFF, 
                Zero, 
                LNKG, 
                Zero
            }, 
            Package (0x04)
            {
                0x000CFFFF, 
                Zero, 
                LNKG, 
                Zero
            }, 
            Package (0x04)
            {
                0x000DFFFF, 
                Zero, 
                LNKG, 
                Zero
            }
        })
        Name (AR00, Package (0x1A)
        {
            Package (0x04)
            {
                0x0014FFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0014FFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x0014FFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0014FFFF, 
                0x03, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x0012FFFF, 
                Zero, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0012FFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x0013FFFF, 
                Zero, 
                Zero, 
                0x14
            }, 
            Package (0x04)
            {
                0x0013FFFF, 
                One, 
                Zero, 
                0x15
            }, 
            Package (0x04)
            {
                0x0016FFFF, 
                Zero, 
                Zero, 
                0x16
            }, 
            Package (0x04)
            {
                0x0016FFFF, 
                One, 
                Zero, 
                0x17
            }, 
            Package (0x04)
            {
                0x0011FFFF, 
                Zero, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x0015FFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0015FFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x0015FFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0015FFFF, 
                0x03, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x37
            }, 
            Package (0x04)
            {
                0x0002FFFF, 
                Zero, 
                Zero, 
                0x34
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                Zero, 
                Zero, 
                0x34
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                Zero, 
                Zero, 
                0x34
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                Zero, 
                Zero, 
                0x35
            }, 
            Package (0x04)
            {
                0x0007FFFF, 
                Zero, 
                Zero, 
                0x35
            }, 
            Package (0x04)
            {
                0x0009FFFF, 
                Zero, 
                Zero, 
                0x35
            }, 
            Package (0x04)
            {
                0x000AFFFF, 
                Zero, 
                Zero, 
                0x36
            }, 
            Package (0x04)
            {
                0x000BFFFF, 
                Zero, 
                Zero, 
                0x36
            }, 
            Package (0x04)
            {
                0x000CFFFF, 
                Zero, 
                Zero, 
                0x36
            }, 
            Package (0x04)
            {
                0x000DFFFF, 
                Zero, 
                Zero, 
                0x36
            }
        })
        Name (PR20, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKD, 
                Zero
            }
        })
        Name (AR20, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x13
            }
        })
        Name (PR21, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKA, 
                Zero
            }
        })
        Name (AR21, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x10
            }
        })
        Name (PR22, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKB, 
                Zero
            }
        })
        Name (AR22, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x11
            }
        })
        Name (PR23, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKC, 
                Zero
            }
        })
        Name (AR23, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x12
            }
        })
        Name (PR12, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKD, 
                Zero
            }
        })
        Name (AR12, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x18
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x19
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x1A
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x1B
            }
        })
        Name (PR14, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKE, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKF, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKG, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKH, 
                Zero
            }
        })
        Name (AR14, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x2C
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x2D
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x2E
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x2F
            }
        })
        Name (PR15, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKG, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKH, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKE, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKF, 
                Zero
            }
        })
        Name (AR15, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x2E
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x2F
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x2C
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x2D
            }
        })
        Name (PR16, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKC, 
                Zero
            }
        })
        Name (AR16, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x33
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x30
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x31
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x32
            }
        })
        Name (PR17, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKB, 
                Zero
            }
        })
        Name (AR17, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x32
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x33
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x30
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x31
            }
        })
        Name (PR19, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKD, 
                Zero
            }
        })
        Name (AR19, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x30
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x31
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x32
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x33
            }
        })
        Name (PR1A, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKH, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKE, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKF, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKG, 
                Zero
            }
        })
        Name (AR1A, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x2F
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x2C
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x2D
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x2E
            }
        })
        Name (PR1B, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKD, 
                Zero
            }
        })
        Name (AR1B, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x20
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x21
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x22
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x23
            }
        })
        Name (PR1C, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKE, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKF, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKG, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKH, 
                Zero
            }
        })
        Name (AR1C, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x24
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x25
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x26
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x27
            }
        })
        Name (PR1D, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKD, 
                Zero
            }
        })
        Name (AR1D, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x28
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x29
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x2A
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x2B
            }
        })
        Name (PR0C, Package (0x04)
        {
            Package (0x04)
            {
                0x0005FFFF, 
                Zero, 
                LNKE, 
                Zero
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                One, 
                LNKF, 
                Zero
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                0x02, 
                LNKG, 
                Zero
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                0x03, 
                LNKH, 
                Zero
            }
        })
        Name (AR0C, Package (0x04)
        {
            Package (0x04)
            {
                0x0005FFFF, 
                Zero, 
                Zero, 
                0x14
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                One, 
                Zero, 
                0x15
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                0x02, 
                Zero, 
                0x16
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                0x03, 
                Zero, 
                0x17
            }
        })
        Name (PRSA, ResourceTemplate ()
        {
            IRQ (Level, ActiveLow, Shared, )
                {4,7,10,11,14,15}
        })
        Alias (PRSA, PRSB)
        Alias (PRSA, PRSC)
        Name (PRSD, ResourceTemplate ()
        {
            IRQ (Level, ActiveLow, Shared, )
                {3,4,10,11,14,15}
        })
        Alias (PRSA, PRSE)
        Alias (PRSA, PRSF)
        Alias (PRSA, PRSG)
        Alias (PRSA, PRSH)
        Device (PCI0)
        {
            Name (_HID, EisaId ("PNP0A03"))
            Name (_ADR, 0x00180000)
            Method (^BN00, 0, NotSerialized)
            {
                Return (Zero)
            }
            Method (_BBN, 0, NotSerialized)
            {
                Return (BN00 ())
            }
            Name (_UID, Zero)
            Method (_PRT, 0, NotSerialized)
            {
                If (PICM)
                {
                    Return (AR00)
                }
                Return (PR00)
            }
            Name (CPRB, One)
            Name (LVGA, 0x55)
            Name (BRB, 0x0000)
            Name (BRL, 0x0100)
            Name (IOB, 0x1000)
            Name (IOL, 0xF000)
            Name (MBB, 0xE0000000)
            Name (MBL, 0x20000000)
            Name (MABL, 0x00000000)
            Name (MABH, 0x00000000)
            Name (MALL, 0x00000000)
            Name (MALH, 0x00000000)
            Name (MAML, 0x00000000)
            Name (MAMH, 0x00000000)
            Name (CRS1, ResourceTemplate ()
            {
                WordBusNumber (ResourceProducer, MinFixed, MaxFixed, PosDecode,
                    0x0000,             // Granularity
                    0x0000,             // Range Minimum
                    0x007F,             // Range Maximum
                    0x0000,             // Translation Offset
                    0x0080,             // Length
                    ,, _Y00)
                IO (Decode16,
                    0x0CF8,             // Range Minimum
                    0x0CF8,             // Range Maximum
                    0x01,               // Alignment
                    0x08,               // Length
                    )
                WordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                    0x0000,             // Granularity
                    0x0000,             // Range Minimum
                    0x03AF,             // Range Maximum
                    0x0000,             // Translation Offset
                    0x03B0,             // Length
                    ,, , TypeStatic)
                WordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                    0x0000,             // Granularity
                    0x03E0,             // Range Minimum
                    0x0CF7,             // Range Maximum
                    0x0000,             // Translation Offset
                    0x0918,             // Length
                    ,, , TypeStatic)
                WordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                    0x0000,             // Granularity
                    0x0000,             // Range Minimum
                    0x0000,             // Range Maximum
                    0x0000,             // Translation Offset
                    0x0000,             // Length
                    ,, _Y02, TypeStatic)
                WordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                    0x0000,             // Granularity
                    0x0D00,             // Range Minimum
                    0x0FFF,             // Range Maximum
                    0x0000,             // Translation Offset
                    0x0300,             // Length
                    ,, _Y01, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x00000000,         // Range Minimum
                    0x00000000,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00000000,         // Length
                    ,, _Y03, AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, NonCacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000C0000,         // Range Minimum
                    0x000DFFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00020000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x02000000,         // Range Minimum
                    0xFFDFFFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0xfde00000,         // Length
                    ,, _Y04, AddressRangeMemory, TypeStatic)
                QWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x0000000000000000, // Granularity
                    0x0000000000000000, // Range Minimum
                    0x0000000000000000, // Range Maximum
                    0x0000000000000000, // Translation Offset
                    0x0000000000000000, // Length
                    ,, _Y05, AddressRangeMemory, TypeStatic)
            })
            Name (CRS2, ResourceTemplate ()
            {
                WordBusNumber (ResourceProducer, MinFixed, MaxFixed, PosDecode,
                    0x0000,             // Granularity
                    0x0080,             // Range Minimum
                    0x00FF,             // Range Maximum
                    0x0000,             // Translation Offset
                    0x0080,             // Length
                    ,, _Y06)
                WordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                    0x0000,             // Granularity
                    0x0000,             // Range Minimum
                    0x0000,             // Range Maximum
                    0x0000,             // Translation Offset
                    0x0000,             // Length
                    ,, _Y08, TypeStatic)
                WordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                    0x0000,             // Granularity
                    0x0000,             // Range Minimum
                    0x0000,             // Range Maximum
                    0x0000,             // Translation Offset
                    0x0000,             // Length
                    ,, _Y07, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x00000000,         // Range Minimum
                    0x00000000,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00000000,         // Length
                    ,, _Y09, AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x80000000,         // Range Minimum
                    0xFFFFFFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x80000000,         // Length
                    ,, _Y0A, AddressRangeMemory, TypeStatic)
                QWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x0000000000000000, // Granularity
                    0x0000000000000000, // Range Minimum
                    0x0000000000000000, // Range Maximum
                    0x0000000000000000, // Translation Offset
                    0x0000000000000000, // Length
                    ,, _Y0B, AddressRangeMemory, TypeStatic)
            })
            Method (_CRS, 0, NotSerialized)
            {
                If (CPRB)
                {
                    CreateWordField (CRS1, \_SB.PCI0._Y00._MIN, MIN0)
                    CreateWordField (CRS1, \_SB.PCI0._Y00._MAX, MAX0)
                    CreateWordField (CRS1, \_SB.PCI0._Y00._LEN, LEN0)
                    Store (BRB, MIN0)
                    Store (BRL, LEN0)
                    Store (LEN0, Local0)
                    Add (MIN0, Decrement (Local0), MAX0)
                    CreateWordField (CRS1, \_SB.PCI0._Y01._MIN, MIN1)
                    CreateWordField (CRS1, \_SB.PCI0._Y01._MAX, MAX1)
                    CreateWordField (CRS1, \_SB.PCI0._Y01._LEN, LEN1)
                    If (LEqual (IOB, 0x1000))
                    {
                        Store (IOL, Local0)
                        Add (IOB, Decrement (Local0), MAX1)
                        Subtract (MAX1, MIN1, Local0)
                        Add (Local0, One, LEN1)
                    }
                    Else
                    {
                        Store (IOB, MIN1)
                        Store (IOL, LEN1)
                        Store (LEN1, Local0)
                        Add (MIN1, Decrement (Local0), MAX1)
                    }
                    If (LOr (LEqual (LVGA, One), LEqual (LVGA, 0x55)))
                    {
                        If (VGAF)
                        {
                            CreateWordField (CRS1, \_SB.PCI0._Y02._MIN, IMN1)
                            CreateWordField (CRS1, \_SB.PCI0._Y02._MAX, IMX1)
                            CreateWordField (CRS1, \_SB.PCI0._Y02._LEN, ILN1)
                            Store (0x03B0, IMN1)
                            Store (0x03DF, IMX1)
                            Store (0x30, ILN1)
                            CreateDWordField (CRS1, \_SB.PCI0._Y03._MIN, VMN1)
                            CreateDWordField (CRS1, \_SB.PCI0._Y03._MAX, VMX1)
                            CreateDWordField (CRS1, \_SB.PCI0._Y03._LEN, VLN1)
                            Store (0x000A0000, VMN1)
                            Store (0x000BFFFF, VMX1)
                            Store (0x00020000, VLN1)
                            Store (Zero, VGAF)
                        }
                    }
                    CreateDWordField (CRS1, \_SB.PCI0._Y04._MIN, MIN3)
                    CreateDWordField (CRS1, \_SB.PCI0._Y04._MAX, MAX3)
                    CreateDWordField (CRS1, \_SB.PCI0._Y04._LEN, LEN3)
                    Store (MBB, MIN3)
                    Store (MBL, LEN3)
                    Store (LEN3, Local0)
                    Add (MIN3, Decrement (Local0), MAX3)
                    If (LOr (MALH, MALL))
                    {
                        CreateDWordField (CRS1, \_SB.PCI0._Y05._MIN, MN8L)
                        Add (0xB4, 0x04, Local0)
                        CreateDWordField (CRS1, Local0, MN8H)
                        Store (MABL, MN8L)
                        Store (MABH, MN8H)
                        CreateDWordField (CRS1, \_SB.PCI0._Y05._MAX, MX8L)
                        Add (0xBC, 0x04, Local1)
                        CreateDWordField (CRS1, Local1, MX8H)
                        CreateDWordField (CRS1, \_SB.PCI0._Y05._LEN, LN8L)
                        Add (0xCC, 0x04, Local2)
                        CreateDWordField (CRS1, Local2, LN8H)
                        Store (MABL, MN8L)
                        Store (MABH, MN8H)
                        Store (MALL, LN8L)
                        Store (MALH, LN8H)
                        Store (MAML, MX8L)
                        Store (MAMH, MX8H)
                    }
                    Return (CRS1)
                }
                Else
                {
                    CreateWordField (CRS2, \_SB.PCI0._Y06._MIN, MIN2)
                    CreateWordField (CRS2, \_SB.PCI0._Y06._MAX, MAX2)
                    CreateWordField (CRS2, \_SB.PCI0._Y06._LEN, LEN2)
                    Store (BRB, MIN2)
                    Store (BRL, LEN2)
                    Store (LEN2, Local1)
                    Add (MIN2, Decrement (Local1), MAX2)
                    CreateWordField (CRS2, \_SB.PCI0._Y07._MIN, MIN4)
                    CreateWordField (CRS2, \_SB.PCI0._Y07._MAX, MAX4)
                    CreateWordField (CRS2, \_SB.PCI0._Y07._LEN, LEN4)
                    Store (IOB, MIN4)
                    Store (IOL, LEN4)
                    Store (LEN4, Local1)
                    Add (MIN4, Decrement (Local1), MAX4)
                    If (LVGA)
                    {
                        CreateWordField (CRS2, \_SB.PCI0._Y08._MIN, IMN2)
                        CreateWordField (CRS2, \_SB.PCI0._Y08._MAX, IMX2)
                        CreateWordField (CRS2, \_SB.PCI0._Y08._LEN, ILN2)
                        Store (0x03B0, IMN2)
                        Store (0x03DF, IMX2)
                        Store (0x30, ILN2)
                        CreateDWordField (CRS2, \_SB.PCI0._Y09._MIN, VMN2)
                        CreateDWordField (CRS2, \_SB.PCI0._Y09._MAX, VMX2)
                        CreateDWordField (CRS2, \_SB.PCI0._Y09._LEN, VLN2)
                        Store (0x000A0000, VMN2)
                        Store (0x000BFFFF, VMX2)
                        Store (0x00020000, VLN2)
                    }
                    CreateDWordField (CRS2, \_SB.PCI0._Y0A._MIN, MIN5)
                    CreateDWordField (CRS2, \_SB.PCI0._Y0A._MAX, MAX5)
                    CreateDWordField (CRS2, \_SB.PCI0._Y0A._LEN, LEN5)
                    Store (MBB, MIN5)
                    Store (MBL, LEN5)
                    Store (LEN5, Local1)
                    Add (MIN5, Decrement (Local1), MAX5)
                    If (LOr (MALH, MALL))
                    {
                        CreateDWordField (CRS2, \_SB.PCI0._Y0B._MIN, MN9L)
                        Add (0x72, 0x04, Local0)
                        CreateDWordField (CRS2, Local0, MN9H)
                        CreateDWordField (CRS2, \_SB.PCI0._Y0B._MAX, MX9L)
                        Add (0x7A, 0x04, Local1)
                        CreateDWordField (CRS2, Local1, MX9H)
                        CreateDWordField (CRS2, \_SB.PCI0._Y0B._LEN, LN9L)
                        Add (0x8A, 0x04, Local2)
                        CreateDWordField (CRS2, Local2, LN9H)
                        Store (MABL, MN9L)
                        Store (MABH, MN9H)
                        Store (MALL, LN9L)
                        Store (MALH, LN9H)
                        Store (MAML, MX9L)
                        Store (MAMH, MX9H)
                    }
                    Return (CRS2)
                }
            }
            Scope (\_SB)
            {
                Scope (PCI0)
                {
                    Device (AMDN)
                    {
                        Name (_HID, EisaId ("PNP0C01"))
                        Name (_UID, 0xC8)
                        Name (_STA, 0x0F)
                        Name (NPTR, ResourceTemplate ()
                        {
                            Memory32Fixed (ReadWrite,
                                0x00000000,         // Address Base
                                0x00000000,         // Address Length
                                _Y0C)
                        })
                        Method (_CRS, 0, NotSerialized)
                        {
                            CreateDWordField (NPTR, \_SB.PCI0.AMDN._Y0C._LEN, PL)
                            CreateDWordField (NPTR, \_SB.PCI0.AMDN._Y0C._BAS, PB)
                            Store (PEBS, PB)
                            Store (PEBL, PL)
                            Return (NPTR)
                        }
                    }
                }
            }
            Method (NPTS, 1, NotSerialized)
            {
            }
            Method (NWAK, 1, NotSerialized)
            {
            }
            Device (SMBS)
            {
                Name (_ADR, 0x00140000)
                OperationRegion (SMBS, PCI_Config, Zero, 0x0100)
                Field (SMBS, AnyAcc, NoLock, Preserve)
                {
                    Offset (0x08), 
                    REV,    8, 
                    Offset (0x62), 
                    I1F,    1, 
                    I12F,   1, 
                        ,   2, 
                    MT3A,   1, 
                    Offset (0xF8), 
                    EIDX,   8, 
                    Offset (0xFC), 
                    EDAT,   32
                }
                IndexField (EIDX, EDAT, ByteAcc, NoLock, Preserve)
                {
                    Offset (0x04), 
                    Offset (0x05), 
                        ,   3, 
                    G39E,   1, 
                    G41E,   1, 
                    Offset (0x06), 
                    Offset (0x07), 
                        ,   3, 
                    G39O,   1, 
                    G41O,   1
                }
                OperationRegion (WIDE, PCI_Config, 0xAD, One)
                Field (WIDE, AnyAcc, NoLock, Preserve)
                {
                    DUM1,   4, 
                    SOPT,   1
                }
                OperationRegion (GPIO, SystemMemory, GIOB, 0x0100)
                Field (GPIO, AnyAcc, NoLock, Preserve)
                {
                    Offset (0x06), 
                        ,   5, 
                    G06E,   1, 
                    G06O,   1, 
                    G06I,   1, 
                    G07B,   8, 
                    Offset (0x0B), 
                    G0BB,   8, 
                    Offset (0x0E), 
                    G0EB,   8, 
                    Offset (0x14), 
                        ,   5, 
                    G14E,   1, 
                    G14O,   1, 
                    G14I,   1, 
                        ,   5, 
                    G15E,   1, 
                    G15O,   1, 
                    G15I,   1, 
                    Offset (0x1C), 
                        ,   7, 
                    G1CI,   1, 
                    Offset (0x2D), 
                        ,   5, 
                    G2DE,   1, 
                    G2DO,   1, 
                    G2DI,   1, 
                    Offset (0x35), 
                        ,   5, 
                    G35E,   1, 
                    G35O,   1, 
                    Offset (0x37), 
                        ,   5, 
                    G37E,   1, 
                    G37O,   1, 
                    G37I,   1, 
                    Offset (0x65), 
                        ,   7, 
                    GE05,   1, 
                    Offset (0x6F), 
                        ,   7, 
                    GE15,   1, 
                        ,   7, 
                    GE16,   1, 
                    Offset (0x76), 
                        ,   7, 
                    GE22,   1, 
                    Offset (0xAA), 
                        ,   5, 
                    GAAE,   1, 
                    GAAO,   1, 
                    GAAI,   1, 
                    Offset (0xAF), 
                    GAFB,   8, 
                    GB0B,   8
                }
                OperationRegion (GPMX, SystemMemory, IOMB, 0x0100)
                Field (GPMX, AnyAcc, NoLock, Preserve)
                {
                    Offset (0x06), 
                    G06M,   8, 
                    G07M,   8, 
                    Offset (0x0B), 
                    G0BM,   8, 
                    Offset (0x0E), 
                    G0EM,   8, 
                    Offset (0x14), 
                    G14M,   8, 
                    G15M,   8, 
                    Offset (0x1C), 
                    G1CM,   8, 
                    Offset (0x2D), 
                    G2DM,   8, 
                    Offset (0x37), 
                    G37M,   8, 
                    Offset (0x70), 
                    G70M,   8, 
                    Offset (0x76), 
                    G76M,   8, 
                    Offset (0xAF), 
                    GAFM,   8, 
                    GB0M,   8
                }
            }
            Device (IDEC)
            {
                Name (_ADR, 0x00140001)
                Name (UDMT, Package (0x08)
                {
                    0x78, 
                    0x5A, 
                    0x3C, 
                    0x2D, 
                    0x1E, 
                    0x14, 
                    0x0F, 
                    Zero
                })
                Name (PIOT, Package (0x06)
                {
                    0x0258, 
                    0x0186, 
                    0x010E, 
                    0xB4, 
                    0x78, 
                    Zero
                })
                Name (PITR, Package (0x06)
                {
                    0x99, 
                    0x47, 
                    0x34, 
                    0x22, 
                    0x20, 
                    0x99
                })
                Name (MDMT, Package (0x04)
                {
                    0x01E0, 
                    0x96, 
                    0x78, 
                    Zero
                })
                Name (MDTR, Package (0x04)
                {
                    0x77, 
                    0x21, 
                    0x20, 
                    0xFF
                })
                OperationRegion (IDE, PCI_Config, 0x40, 0x20)
                Field (IDE, AnyAcc, NoLock, Preserve)
                {
                    PPIT,   16, 
                    SPIT,   16, 
                    PMDT,   16, 
                    SMDT,   16, 
                    PPIC,   8, 
                    SPIC,   8, 
                    PPIM,   8, 
                    SPIM,   8, 
                    Offset (0x14), 
                    PUDC,   2, 
                    SUDC,   2, 
                    Offset (0x16), 
                    PUDM,   8, 
                    SUDM,   8
                }
                Method (GETT, 1, NotSerialized)
                {
                    Store (And (Arg0, 0x0F), Local0)
                    Store (ShiftRight (Arg0, 0x04), Local1)
                    Return (Multiply (0x1E, Add (Add (Local0, One), Add (Local1, 
                        One))))
                }
                Method (GTM, 1, NotSerialized)
                {
                    CreateByteField (Arg0, Zero, PIT1)
                    CreateByteField (Arg0, One, PIT0)
                    CreateByteField (Arg0, 0x02, MDT1)
                    CreateByteField (Arg0, 0x03, MDT0)
                    CreateByteField (Arg0, 0x04, PICX)
                    CreateByteField (Arg0, 0x05, UDCX)
                    CreateByteField (Arg0, 0x06, UDMX)
                    Name (BUF, Buffer (0x14)
                    {
                        /* 0000 */   0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
                        /* 0008 */   0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
                        /* 0010 */   0x00, 0x00, 0x00, 0x00
                    })
                    CreateDWordField (BUF, Zero, PIO0)
                    CreateDWordField (BUF, 0x04, DMA0)
                    CreateDWordField (BUF, 0x08, PIO1)
                    CreateDWordField (BUF, 0x0C, DMA1)
                    CreateDWordField (BUF, 0x10, FLAG)
                    If (And (PICX, One))
                    {
                        Return (BUF)
                    }
                    Store (GETT (PIT0), PIO0)
                    Store (GETT (PIT1), PIO1)
                    If (And (UDCX, One))
                    {
                        Or (FLAG, One, FLAG)
                        Store (DerefOf (Index (UDMT, And (UDMX, 0x0F))), DMA0)
                    }
                    Else
                    {
                        Store (GETT (MDT0), DMA0)
                    }
                    If (And (UDCX, 0x02))
                    {
                        Or (FLAG, 0x04, FLAG)
                        Store (DerefOf (Index (UDMT, ShiftRight (UDMX, 0x04))), DMA1)
                    }
                    Else
                    {
                        Store (GETT (MDT1), DMA1)
                    }
                    Or (FLAG, 0x1A, FLAG)
                    Return (BUF)
                }
                Method (STM, 3, NotSerialized)
                {
                    CreateDWordField (Arg0, Zero, PIO0)
                    CreateDWordField (Arg0, 0x04, DMA0)
                    CreateDWordField (Arg0, 0x08, PIO1)
                    CreateDWordField (Arg0, 0x0C, DMA1)
                    CreateDWordField (Arg0, 0x10, FLAG)
                    Name (BUF, Buffer (0x07)
                    {
                         0x00, 0x00, 0xFF, 0xFF, 0x00, 0x00, 0x00
                    })
                    CreateByteField (BUF, Zero, PIT1)
                    CreateByteField (BUF, One, PIT0)
                    CreateByteField (BUF, 0x02, MDT1)
                    CreateByteField (BUF, 0x03, MDT0)
                    CreateByteField (BUF, 0x04, PIMX)
                    CreateByteField (BUF, 0x05, UDCX)
                    CreateByteField (BUF, 0x06, UDMX)
                    Store (Match (PIOT, MLE, PIO0, MTR, Zero, Zero), Local0)
                    Divide (Local0, 0x05, Local0)
                    Store (Match (PIOT, MLE, PIO1, MTR, Zero, Zero), Local1)
                    Divide (Local1, 0x05, Local1)
                    Store (Or (ShiftLeft (Local1, 0x04), Local0), PIMX)
                    Store (DerefOf (Index (PITR, Local0)), PIT0)
                    Store (DerefOf (Index (PITR, Local1)), PIT1)
                    If (And (FLAG, One))
                    {
                        Store (Match (UDMT, MLE, DMA0, MTR, Zero, Zero), Local0)
                        Divide (Local0, 0x07, Local0)
                        Or (UDMX, Local0, UDMX)
                        Or (UDCX, One, UDCX)
                    }
                    Else
                    {
                        If (LNotEqual (DMA0, 0xFFFFFFFF))
                        {
                            Store (Match (MDMT, MLE, DMA0, MTR, Zero, Zero), Local0)
                            Store (DerefOf (Index (MDTR, Local0)), MDT0)
                        }
                    }
                    If (And (FLAG, 0x04))
                    {
                        Store (Match (UDMT, MLE, DMA1, MTR, Zero, Zero), Local0)
                        Divide (Local0, 0x07, Local0)
                        Or (UDMX, ShiftLeft (Local0, 0x04), UDMX)
                        Or (UDCX, 0x02, UDCX)
                    }
                    Else
                    {
                        If (LNotEqual (DMA1, 0xFFFFFFFF))
                        {
                            Store (Match (MDMT, MLE, DMA1, MTR, Zero, Zero), Local0)
                            Store (DerefOf (Index (MDTR, Local0)), MDT1)
                        }
                    }
                    Return (BUF)
                }
                Method (GTF, 2, NotSerialized)
                {
                    CreateByteField (Arg1, Zero, MDT1)
                    CreateByteField (Arg1, One, MDT0)
                    CreateByteField (Arg1, 0x02, PIMX)
                    CreateByteField (Arg1, 0x03, UDCX)
                    CreateByteField (Arg1, 0x04, UDMX)
                    If (LEqual (Arg0, 0xA0))
                    {
                        Store (And (PIMX, 0x0F), Local0)
                        Store (MDT0, Local1)
                        And (UDCX, One, Local2)
                        Store (And (UDMX, 0x0F), Local3)
                    }
                    Else
                    {
                        Store (ShiftRight (PIMX, 0x04), Local0)
                        Store (MDT1, Local1)
                        And (UDCX, 0x02, Local2)
                        Store (ShiftRight (UDMX, 0x04), Local3)
                    }
                    Name (BUF, Buffer (0x15)
                    {
                        /* 0000 */   0x03, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xEF, 0x03,
                        /* 0008 */   0x00, 0x00, 0x00, 0x00, 0xFF, 0xEF, 0x00, 0x00,
                        /* 0010 */   0x00, 0x00, 0x00, 0x00, 0xF5
                    })
                    CreateByteField (BUF, One, PMOD)
                    CreateByteField (BUF, 0x08, DMOD)
                    CreateByteField (BUF, 0x05, CMDA)
                    CreateByteField (BUF, 0x0C, CMDB)
                    CreateByteField (BUF, 0x13, CMDC)
                    Store (Arg0, CMDA)
                    Store (Arg0, CMDB)
                    Store (Arg0, CMDC)
                    Or (Local0, 0x08, PMOD)
                    If (Local2)
                    {
                        Or (Local3, 0x40, DMOD)
                    }
                    Else
                    {
                        Store (Match (MDMT, MLE, GETT (Local1), MTR, Zero, Zero), Local4)
                        If (LLess (Local4, 0x03))
                        {
                            Or (0x20, Local4, DMOD)
                        }
                    }
                    Return (BUF)
                }
                Device (PRID)
                {
                    Name (_ADR, Zero)
                    Method (_GTM, 0, NotSerialized)
                    {
                        Name (BUF, Buffer (0x07)
                        {
                             0x00, 0x00, 0xFF, 0xFF, 0x00, 0x00, 0x00
                        })
                        CreateWordField (BUF, Zero, VPIT)
                        CreateWordField (BUF, 0x02, VMDT)
                        CreateByteField (BUF, 0x04, VPIC)
                        CreateByteField (BUF, 0x05, VUDC)
                        CreateByteField (BUF, 0x06, VUDM)
                        If (LOr (LGreaterEqual (^^^SMBS.REV, 0x3A), ^^^SMBS.SOPT))
                        {
                            Store (PPIT, VPIT)
                            Store (PMDT, VMDT)
                            Store (PPIC, VPIC)
                            Store (PUDC, VUDC)
                            Store (PUDM, VUDM)
                        }
                        Else
                        {
                            Store (SPIT, VPIT)
                            Store (SMDT, VMDT)
                            Store (SPIC, VPIC)
                            Store (SUDC, VUDC)
                            Store (SUDM, VUDM)
                        }
                        Return (GTM (BUF))
                    }
                    Method (_STM, 3, NotSerialized)
                    {
                        Name (BUF, Buffer (0x07)
                        {
                             0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
                        })
                        CreateWordField (BUF, Zero, VPIT)
                        CreateWordField (BUF, 0x02, VMDT)
                        CreateByteField (BUF, 0x04, VPIM)
                        CreateByteField (BUF, 0x05, VUDC)
                        CreateByteField (BUF, 0x06, VUDM)
                        Store (STM (Arg0, Arg1, Arg2), BUF)
                        If (LOr (LGreaterEqual (^^^SMBS.REV, 0x3A), ^^^SMBS.SOPT))
                        {
                            Store (VPIT, PPIT)
                            Store (VMDT, PMDT)
                            Store (VPIM, PPIM)
                            Store (VUDC, PUDC)
                            Store (VUDM, PUDM)
                        }
                        Else
                        {
                            Store (VPIT, SPIT)
                            Store (VMDT, SMDT)
                            Store (VPIM, SPIM)
                            Store (VUDC, SUDC)
                            Store (VUDM, SUDM)
                        }
                    }
                    Device (P_D0)
                    {
                        Name (_ADR, Zero)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Name (BUF, Buffer (0x05)
                            {
                                 0x00, 0x00, 0x00, 0x00, 0x00
                            })
                            CreateWordField (BUF, Zero, VMDT)
                            CreateByteField (BUF, 0x02, VPIM)
                            CreateByteField (BUF, 0x03, VUDC)
                            CreateByteField (BUF, 0x04, VUDM)
                            If (LOr (LGreaterEqual (^^^^SMBS.REV, 0x3A), ^^^^SMBS.SOPT))
                            {
                                Store (PMDT, VMDT)
                                Store (PPIM, VPIM)
                                Store (PUDC, VUDC)
                                Store (PUDM, VUDM)
                            }
                            Else
                            {
                                Store (SMDT, VMDT)
                                Store (SPIM, VPIM)
                                Store (SUDC, VUDC)
                                Store (SUDM, VUDM)
                            }
                            Return (GTF (0xA0, BUF))
                        }
                    }
                    Device (P_D1)
                    {
                        Name (_ADR, One)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Name (BUF, Buffer (0x05)
                            {
                                 0x00, 0x00, 0x00, 0x00, 0x00
                            })
                            CreateWordField (BUF, Zero, VMDT)
                            CreateByteField (BUF, 0x02, VPIM)
                            CreateByteField (BUF, 0x03, VUDC)
                            CreateByteField (BUF, 0x04, VUDM)
                            If (LOr (LGreaterEqual (^^^^SMBS.REV, 0x3A), ^^^^SMBS.SOPT))
                            {
                                Store (PMDT, VMDT)
                                Store (PPIM, VPIM)
                                Store (PUDC, VUDC)
                                Store (PUDM, VUDM)
                            }
                            Else
                            {
                                Store (SMDT, VMDT)
                                Store (SPIM, VPIM)
                                Store (SUDC, VUDC)
                                Store (SUDM, VUDM)
                            }
                            Return (GTF (0xB0, BUF))
                        }
                    }
                }
                Device (SECD)
                {
                    Name (_ADR, One)
                    Method (_GTM, 0, NotSerialized)
                    {
                        Name (BUF, Buffer (0x07)
                        {
                             0x00, 0x00, 0xFF, 0xFF, 0x00, 0x00, 0x00
                        })
                        CreateWordField (BUF, Zero, VPIT)
                        CreateWordField (BUF, 0x02, VMDT)
                        CreateByteField (BUF, 0x04, VPIC)
                        CreateByteField (BUF, 0x05, VUDC)
                        CreateByteField (BUF, 0x06, VUDM)
                        If (LOr (LGreaterEqual (^^^SMBS.REV, 0x3A), ^^^SMBS.SOPT))
                        {
                            Store (SPIT, VPIT)
                            Store (SMDT, VMDT)
                            Store (SPIC, VPIC)
                            Store (SUDC, VUDC)
                            Store (SUDM, VUDM)
                        }
                        Else
                        {
                            Store (PPIT, VPIT)
                            Store (PMDT, VMDT)
                            Store (PPIC, VPIC)
                            Store (PUDC, VUDC)
                            Store (PUDM, VUDM)
                        }
                        Return (GTM (BUF))
                    }
                    Method (_STM, 3, NotSerialized)
                    {
                        Name (BUF, Buffer (0x07)
                        {
                             0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
                        })
                        CreateWordField (BUF, Zero, VPIT)
                        CreateWordField (BUF, 0x02, VMDT)
                        CreateByteField (BUF, 0x04, VPIM)
                        CreateByteField (BUF, 0x05, VUDC)
                        CreateByteField (BUF, 0x06, VUDM)
                        Store (STM (Arg0, Arg1, Arg2), BUF)
                        If (LOr (LGreaterEqual (^^^SMBS.REV, 0x3A), ^^^SMBS.SOPT))
                        {
                            Store (VPIT, SPIT)
                            Store (VMDT, SMDT)
                            Store (VPIM, SPIM)
                            Store (VUDC, SUDC)
                            Store (VUDM, SUDM)
                        }
                        Else
                        {
                            Store (VPIT, PPIT)
                            Store (VMDT, PMDT)
                            Store (VPIM, PPIM)
                            Store (VUDC, PUDC)
                            Store (VUDM, PUDM)
                        }
                    }
                    Device (S_D0)
                    {
                        Name (_ADR, Zero)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Name (BUF, Buffer (0x05)
                            {
                                 0x00, 0x00, 0x00, 0x00, 0x00
                            })
                            CreateWordField (BUF, Zero, VMDT)
                            CreateByteField (BUF, 0x02, VPIM)
                            CreateByteField (BUF, 0x03, VUDC)
                            CreateByteField (BUF, 0x04, VUDM)
                            If (LOr (LGreaterEqual (^^^^SMBS.REV, 0x3A), ^^^^SMBS.SOPT))
                            {
                                Store (SMDT, VMDT)
                                Store (SPIM, VPIM)
                                Store (SUDC, VUDC)
                                Store (SUDM, VUDM)
                            }
                            Else
                            {
                                Store (PMDT, VMDT)
                                Store (PPIM, VPIM)
                                Store (PUDC, VUDC)
                                Store (PUDM, VUDM)
                            }
                            Return (GTF (0xA0, BUF))
                        }
                    }
                    Device (S_D1)
                    {
                        Name (_ADR, One)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Name (BUF, Buffer (0x05)
                            {
                                 0x00, 0x00, 0x00, 0x00, 0x00
                            })
                            CreateWordField (BUF, Zero, VMDT)
                            CreateByteField (BUF, 0x02, VPIM)
                            CreateByteField (BUF, 0x03, VUDC)
                            CreateByteField (BUF, 0x04, VUDM)
                            If (LOr (LGreaterEqual (^^^^SMBS.REV, 0x3A), ^^^^SMBS.SOPT))
                            {
                                Store (SMDT, VMDT)
                                Store (SPIM, VPIM)
                                Store (SUDC, VUDC)
                                Store (SUDM, VUDM)
                            }
                            Else
                            {
                                Store (PMDT, VMDT)
                                Store (PPIM, VPIM)
                                Store (PUDC, VUDC)
                                Store (PUDM, VUDM)
                            }
                            Return (GTF (0xB0, BUF))
                        }
                    }
                }
            }
            Device (SBAZ)
            {
                Name (_ADR, 0x00140002)
                OperationRegion (PCI, PCI_Config, Zero, 0x0100)
                Field (PCI, AnyAcc, NoLock, Preserve)
                {
                    Offset (0x42), 
                    DNSP,   1, 
                    DNSO,   1, 
                    ENSR,   1
                }
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x1B, 0x04))
                }
            }
            Device (SBRG)
            {
                Name (_ADR, 0x00140003)
                OperationRegion (RMBS, PCI_Config, Zero, 0x0100)
                Field (RMBS, ByteAcc, NoLock, Preserve)
                {
                    Offset (0x6C), 
                    LR2S,   16, 
                    LR2E,   16
                }
                OperationRegion (SMIP, SystemIO, SMIO, One)
                Field (SMIP, ByteAcc, NoLock, Preserve)
                {
                    SMIC,   8
                }
                OperationRegion (GPIO, SystemMemory, SMIB, 0x0200)
                Field (GPIO, AnyAcc, NoLock, Preserve)
                {
                    Offset (0x88), 
                        ,   1, 
                    CLPS,   1, 
                    Offset (0xB0), 
                        ,   2, 
                    SLPS,   2, 
                    Offset (0x10B), 
                    FSCR,   1, 
                    FSSR,   1, 
                    Offset (0x1BE), 
                        ,   5, 
                    ALLS,   1
                }
                Method (SPTS, 1, NotSerialized)
                {
                }
                Method (SWAK, 1, NotSerialized)
                {
                }
                Method (IPTS, 1, NotSerialized)
                {
                    Store (One, CLPS)
                    Store (One, SLPS)
                    Store (Zero, ALLS)
                    Store (Zero, FSCR)
                    Store (One, FSSR)
                }
                Device (S800)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Name (_UID, 0x0700)
                    Name (_STA, 0x0F)
                    Name (CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x040B,             // Range Minimum
                            0x040B,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x04D6,             // Range Minimum
                            0x04D6,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0C00,             // Range Minimum
                            0x0C00,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0C14,             // Range Minimum
                            0x0C14,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0C50,             // Range Minimum
                            0x0C50,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0C52,             // Range Minimum
                            0x0C52,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0C6C,             // Range Minimum
                            0x0C6C,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0C6F,             // Range Minimum
                            0x0C6F,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0CD0,             // Range Minimum
                            0x0CD0,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0CD2,             // Range Minimum
                            0x0CD2,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0CD4,             // Range Minimum
                            0x0CD4,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0CD6,             // Range Minimum
                            0x0CD6,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0CD8,             // Range Minimum
                            0x0CD8,             // Range Maximum
                            0x00,               // Alignment
                            0x08,               // Length
                            )
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            _Y0D)
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            _Y10)
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            _Y0F)
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            _Y0E)
                        IO (Decode16,
                            0x0900,             // Range Minimum
                            0x0900,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x0910,             // Range Minimum
                            0x0910,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0xFE00,             // Range Minimum
                            0xFE00,             // Range Maximum
                            0x00,               // Alignment
                            0xFF,               // Length
                            )
                        IO (Decode16,
                            0x0060,             // Range Minimum
                            0x0060,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            )
                        IO (Decode16,
                            0x0064,             // Range Minimum
                            0x0064,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            )
                        Memory32Fixed (ReadWrite,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y11)
                        Memory32Fixed (ReadWrite,
                            0xFEE00000,         // Address Base
                            0x00001000,         // Address Length
                            )
                        Memory32Fixed (ReadWrite,
                            0xFED80000,         // Address Base
                            0x00010000,         // Address Length
                            )
                        Memory32Fixed (ReadWrite,
                            0xFED61000,         // Address Base
                            0x00010000,         // Address Length
                            )
                        Memory32Fixed (ReadWrite,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y12)
                        Memory32Fixed (ReadWrite,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y13)
                        Memory32Fixed (ReadWrite,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y14)
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        CreateWordField (CRS, \_SB.PCI0.SBRG.S800._Y0D._MIN, PBB)
                        CreateWordField (CRS, \_SB.PCI0.SBRG.S800._Y0D._MAX, PBH)
                        CreateByteField (CRS, \_SB.PCI0.SBRG.S800._Y0D._LEN, PML)
                        Store (PMBS, PBB)
                        Store (PMBS, PBH)
                        Store (PMLN, PML)
                        If (SMBB)
                        {
                            CreateWordField (CRS, \_SB.PCI0.SBRG.S800._Y0E._MIN, SMB1)
                            CreateWordField (CRS, \_SB.PCI0.SBRG.S800._Y0E._MAX, SMH1)
                            CreateByteField (CRS, \_SB.PCI0.SBRG.S800._Y0E._LEN, SML1)
                            Store (SMBB, SMB1)
                            Store (SMBB, SMH1)
                            Store (SMBL, SML1)
                            CreateWordField (CRS, \_SB.PCI0.SBRG.S800._Y0F._MIN, SMB0)
                            CreateWordField (CRS, \_SB.PCI0.SBRG.S800._Y0F._MAX, SMH0)
                            CreateByteField (CRS, \_SB.PCI0.SBRG.S800._Y0F._LEN, SML0)
                            Store (SMB0, SMB0)
                            Store (SMB0, SMH0)
                            Store (SMBM, SML0)
                        }
                        If (GPBS)
                        {
                            CreateWordField (CRS, \_SB.PCI0.SBRG.S800._Y10._MIN, IGB)
                            CreateWordField (CRS, \_SB.PCI0.SBRG.S800._Y10._MAX, IGH)
                            CreateByteField (CRS, \_SB.PCI0.SBRG.S800._Y10._LEN, IGL)
                            Store (GPBS, IGB)
                            Store (GPBS, IGH)
                            Store (GPLN, IGL)
                        }
                        If (APCB)
                        {
                            CreateDWordField (CRS, \_SB.PCI0.SBRG.S800._Y11._BAS, APB)
                            CreateDWordField (CRS, \_SB.PCI0.SBRG.S800._Y11._LEN, APL)
                            Store (APCB, APB)
                            Store (APCL, APL)
                        }
                        If (SPIB)
                        {
                            CreateDWordField (CRS, \_SB.PCI0.SBRG.S800._Y12._BAS, SPIB)
                            CreateDWordField (CRS, \_SB.PCI0.SBRG.S800._Y12._LEN, SPIL)
                            Store (\SPIB, SPIB)
                            Store (\SPIL, SPIL)
                        }
                        If (HPTB)
                        {
                            CreateDWordField (CRS, \_SB.PCI0.SBRG.S800._Y13._BAS, HXTB)
                            CreateDWordField (CRS, \_SB.PCI0.SBRG.S800._Y13._LEN, HXTL)
                            Store (HPTB, HXTB)
                            Store (HPTL, HXTL)
                        }
                        CreateDWordField (CRS, \_SB.PCI0.SBRG.S800._Y14._BAS, ROMB)
                        CreateDWordField (CRS, \_SB.PCI0.SBRG.S800._Y14._LEN, ROML)
                        If (LR2S)
                        {
                            Store (ShiftLeft (LR2S, 0x10), ROMB)
                            Store (ShiftLeft (Add (Subtract (LR2E, LR2S), One), 0x10
                                ), ROML)
                        }
                        Else
                        {
                            Store (ROMS, ROMB)
                            Subtract (Zero, ROMS, ROML)
                        }
                        Return (CRS)
                    }
                }
                Device (SIO1)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Method (_UID, 0, NotSerialized)
                    {
                        Return (SP1O)
                    }
                    Name (CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            _Y15)
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            _Y16)
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            _Y17)
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        If (LAnd (LLess (SP1O, 0x03F0), LGreater (SP1O, 0xF0)))
                        {
                            CreateWordField (CRS, \_SB.PCI0.SBRG.SIO1._Y15._MIN, GPI0)
                            CreateWordField (CRS, \_SB.PCI0.SBRG.SIO1._Y15._MAX, GPI1)
                            CreateByteField (CRS, \_SB.PCI0.SBRG.SIO1._Y15._LEN, GPIL)
                            Store (SP1O, GPI0)
                            Store (SP1O, GPI1)
                            Store (0x02, GPIL)
                        }
                        If (IO1B)
                        {
                            CreateWordField (CRS, \_SB.PCI0.SBRG.SIO1._Y16._MIN, GP10)
                            CreateWordField (CRS, \_SB.PCI0.SBRG.SIO1._Y16._MAX, GP11)
                            CreateByteField (CRS, \_SB.PCI0.SBRG.SIO1._Y16._LEN, GPL1)
                            Store (IO1B, GP10)
                            Store (IO1B, GP11)
                            Store (IO1L, GPL1)
                        }
                        ENFG (0x03)
                        If (ACTR)
                        {
                            CreateWordField (CRS, \_SB.PCI0.SBRG.SIO1._Y17._MIN, GP20)
                            CreateWordField (CRS, \_SB.PCI0.SBRG.SIO1._Y17._MAX, GP21)
                            CreateByteField (CRS, \_SB.PCI0.SBRG.SIO1._Y17._LEN, GPL2)
                            ShiftLeft (IOAH, 0x08, Local0)
                            Or (IOAL, Local0, Local0)
                            Subtract (FindSetRightBit (Local0), One, Local1)
                            ShiftLeft (One, Local1, Local1)
                            If (And (OPT0, 0x02)) {}
                            Else
                            {
                                Or (Local0, 0x0400, GP20)
                                Or (Local0, 0x0400, GP21)
                                Store (Local1, GPL2)
                            }
                        }
                        EXFG ()
                        Return (CRS)
                    }
                    Name (DCAT, Package (0x15)
                    {
                        One, 
                        0x02, 
                        0x03, 
                        Zero, 
                        0xFF, 
                        0xFF, 
                        0xFF, 
                        0xFF, 
                        0xFF, 
                        0xFF, 
                        0x05, 
                        0xFF, 
                        0xFF, 
                        0xFF, 
                        0xFF, 
                        0xFF, 
                        0x0A, 
                        0xFF, 
                        0xFF, 
                        0xFF, 
                        0xFF
                    })
                    Mutex (MUT0, 0x00)
                    Method (ENFG, 1, NotSerialized)
                    {
                        Acquire (MUT0, 0x0FFF)
                        Store (0x87, INDX)
                        Store (One, INDX)
                        Store (0x55, INDX)
                        If (LEqual (SP1O, 0x2E))
                        {
                            Store (0x55, INDX)
                        }
                        Else
                        {
                            Store (0xAA, INDX)
                        }
                        Store (Arg0, LDN)
                    }
                    Method (EXFG, 0, NotSerialized)
                    {
                        Store (0x02, INDX)
                        Store (0x02, DATA)
                        Release (MUT0)
                    }
                    Method (LPTM, 1, NotSerialized)
                    {
                        ENFG (CGLD (Arg0))
                        And (OPT0, 0x02, Local0)
                        EXFG ()
                        Return (Local0)
                    }
                    Method (UHID, 1, NotSerialized)
                    {
                        ENFG (CGLD (Arg0))
                        And (OPT0, 0x03, Local0)
                        EXFG ()
                        If (Local0)
                        {
                            Return (0x1005D041)
                        }
                        Else
                        {
                            Return (0x0105D041)
                        }
                    }
                    OperationRegion (IOID, SystemIO, SP1O, 0x02)
                    Field (IOID, ByteAcc, NoLock, Preserve)
                    {
                        INDX,   8, 
                        DATA,   8
                    }
                    IndexField (INDX, DATA, ByteAcc, NoLock, Preserve)
                    {
                        Offset (0x07), 
                        LDN,    8, 
                        Offset (0x21), 
                        SCF1,   8, 
                        SCF2,   8, 
                        SCF3,   8, 
                        SCF4,   8, 
                        SCF5,   8, 
                        SCF6,   8, 
                        Offset (0x29), 
                        CKCF,   8, 
                        Offset (0x30), 
                        ACTR,   8, 
                        Offset (0x60), 
                        IOAH,   8, 
                        IOAL,   8, 
                        IOH2,   8, 
                        IOL2,   8, 
                        Offset (0x70), 
                        INTR,   8, 
                        Offset (0x74), 
                        DMCH,   8, 
                        Offset (0xF0), 
                        OPT0,   8, 
                        OPT1,   8, 
                        OPT2,   8, 
                        OPT3,   8, 
                        OPT4,   8, 
                        OPT5,   8, 
                        OPT6,   8
                    }
                    Method (CGLD, 1, NotSerialized)
                    {
                        Return (DerefOf (Index (DCAT, Arg0)))
                    }
                    Method (DSTA, 1, NotSerialized)
                    {
                        ENFG (CGLD (Arg0))
                        Store (ACTR, Local0)
                        EXFG ()
                        If (LEqual (Local0, 0xFF))
                        {
                            Return (Zero)
                        }
                        And (Local0, One, Local0)
                        Or (IOST, ShiftLeft (Local0, Arg0), IOST)
                        If (Local0)
                        {
                            Return (0x0F)
                        }
                        Else
                        {
                            If (And (ShiftLeft (One, Arg0), IOST))
                            {
                                Return (0x0D)
                            }
                            Else
                            {
                                Return (Zero)
                            }
                        }
                    }
                    Method (DCNT, 2, NotSerialized)
                    {
                        ENFG (CGLD (Arg0))
                        If (LAnd (LLess (DMCH, 0x04), LNotEqual (And (DMCH, 0x03, 
                            Local1), Zero)))
                        {
                            RDMA (Arg0, Arg1, Increment (Local1))
                        }
                        Store (Arg1, ACTR)
                        ShiftLeft (IOAH, 0x08, Local1)
                        Or (IOAL, Local1, Local1)
                        RRIO (Arg0, Arg1, Local1, 0x08)
                        EXFG ()
                    }
                    Name (CRS1, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x01,               // Alignment
                            0x00,               // Length
                            _Y1A)
                        IRQNoFlags (_Y18)
                            {}
                        DMA (Compatibility, NotBusMaster, Transfer8, _Y19)
                            {}
                    })
                    CreateWordField (CRS1, \_SB.PCI0.SBRG.SIO1._Y18._INT, IRQM)
                    CreateByteField (CRS1, \_SB.PCI0.SBRG.SIO1._Y19._DMA, DMAM)
                    CreateWordField (CRS1, \_SB.PCI0.SBRG.SIO1._Y1A._MIN, IO11)
                    CreateWordField (CRS1, \_SB.PCI0.SBRG.SIO1._Y1A._MAX, IO12)
                    CreateByteField (CRS1, \_SB.PCI0.SBRG.SIO1._Y1A._LEN, LEN1)
                    Name (CRS2, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x01,               // Alignment
                            0x00,               // Length
                            _Y1D)
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x01,               // Alignment
                            0x00,               // Length
                            _Y1E)
                        IRQNoFlags (_Y1B)
                            {}
                        DMA (Compatibility, NotBusMaster, Transfer8, _Y1C)
                            {2}
                    })
                    CreateWordField (CRS2, \_SB.PCI0.SBRG.SIO1._Y1B._INT, IRQE)
                    CreateByteField (CRS2, \_SB.PCI0.SBRG.SIO1._Y1C._DMA, DMAE)
                    CreateWordField (CRS2, \_SB.PCI0.SBRG.SIO1._Y1D._MIN, IO21)
                    CreateWordField (CRS2, \_SB.PCI0.SBRG.SIO1._Y1D._MAX, IO22)
                    CreateByteField (CRS2, \_SB.PCI0.SBRG.SIO1._Y1D._LEN, LEN2)
                    CreateWordField (CRS2, \_SB.PCI0.SBRG.SIO1._Y1E._MIN, IO31)
                    CreateWordField (CRS2, \_SB.PCI0.SBRG.SIO1._Y1E._MAX, IO32)
                    CreateByteField (CRS2, \_SB.PCI0.SBRG.SIO1._Y1E._LEN, LEN3)
                    Name (CRS4, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x01,               // Alignment
                            0x00,               // Length
                            _Y20)
                        IRQ (Edge, ActiveHigh, Shared, _Y1F)
                            {}
                    })
                    CreateWordField (CRS4, \_SB.PCI0.SBRG.SIO1._Y1F._INT, IRQL)
                    CreateByteField (CRS4, \_SB.PCI0.SBRG.SIO1._Y1F._HE, IRQS)
                    CreateWordField (CRS4, \_SB.PCI0.SBRG.SIO1._Y20._MIN, IOHL)
                    CreateWordField (CRS4, \_SB.PCI0.SBRG.SIO1._Y20._MAX, IORL)
                    CreateByteField (CRS4, \_SB.PCI0.SBRG.SIO1._Y20._ALN, ALMN)
                    CreateByteField (CRS4, \_SB.PCI0.SBRG.SIO1._Y20._LEN, LENG)
                    Method (DCRS, 2, NotSerialized)
                    {
                        ENFG (CGLD (Arg0))
                        ShiftLeft (IOAH, 0x08, IO11)
                        Or (IOAL, IO11, IO11)
                        Store (IO11, IO12)
                        Subtract (FindSetRightBit (IO11), One, Local0)
                        ShiftLeft (One, Local0, LEN1)
                        If (INTR)
                        {
                            ShiftLeft (One, INTR, IRQM)
                        }
                        Else
                        {
                            Store (Zero, IRQM)
                        }
                        If (LOr (LGreater (DMCH, 0x03), LEqual (Arg1, Zero)))
                        {
                            Store (Zero, DMAM)
                        }
                        Else
                        {
                            And (DMCH, 0x03, Local1)
                            ShiftLeft (One, Local1, DMAM)
                        }
                        EXFG ()
                        Return (CRS1)
                    }
                    Method (DCR2, 2, NotSerialized)
                    {
                        ENFG (CGLD (Arg0))
                        ShiftLeft (IOAH, 0x08, IO21)
                        Or (IOAL, IO21, IO21)
                        Store (IO21, IO22)
                        Subtract (FindSetRightBit (IO21), One, Local0)
                        ShiftLeft (One, Local0, LEN2)
                        ShiftLeft (IOH2, 0x08, IO31)
                        Or (IOL2, IO31, IO31)
                        Store (IO21, IO32)
                        Subtract (FindSetRightBit (IO31), One, Local0)
                        ShiftLeft (One, Local0, LEN3)
                        If (INTR)
                        {
                            ShiftLeft (One, INTR, IRQE)
                        }
                        Else
                        {
                            Store (Zero, IRQE)
                        }
                        If (LOr (LGreater (DMCH, 0x03), LEqual (Arg1, Zero)))
                        {
                            Store (Zero, DMAE)
                        }
                        Else
                        {
                            And (DMCH, 0x03, Local1)
                            ShiftLeft (One, Local1, DMAE)
                        }
                        EXFG ()
                        Return (CRS2)
                    }
                    Method (DCR4, 2, NotSerialized)
                    {
                        ENFG (CGLD (Arg0))
                        ShiftLeft (IOAH, 0x08, IOHL)
                        Or (IOAL, IOHL, IOHL)
                        Store (IOHL, IORL)
                        Subtract (FindSetRightBit (IOHL), One, Local0)
                        ShiftLeft (One, Local0, LENG)
                        If (INTR)
                        {
                            And (INTR, 0x0F, INTR)
                            ShiftLeft (One, INTR, IRQL)
                        }
                        Else
                        {
                            Store (Zero, IRQL)
                        }
                        EXFG ()
                        Return (CRS4)
                    }
                    Method (DSRS, 2, NotSerialized)
                    {
                        If (LEqual (Arg1, 0x02))
                        {
                            If (LPTM (0x02))
                            {
                                DSR2 (Arg0, Arg1)
                            }
                        }
                        Else
                        {
                            CreateWordField (Arg0, 0x09, IRQM)
                            CreateByteField (Arg0, 0x0C, DMAM)
                            CreateWordField (Arg0, 0x02, IO11)
                            ENFG (CGLD (Arg1))
                            And (IO11, 0xFF, IOAL)
                            ShiftRight (IO11, 0x08, IOAH)
                            If (IRQM)
                            {
                                FindSetRightBit (IRQM, Local0)
                                Subtract (Local0, One, INTR)
                            }
                            Else
                            {
                                Store (Zero, INTR)
                            }
                            If (DMAM)
                            {
                                FindSetRightBit (DMAM, Local0)
                                Subtract (Local0, One, DMCH)
                            }
                            Else
                            {
                                Store (0x04, DMCH)
                            }
                            EXFG ()
                            DCNT (Arg1, One)
                            Store (Arg1, Local2)
                            If (LGreater (Local2, Zero))
                            {
                                Subtract (Local2, One, Local2)
                            }
                        }
                    }
                    Method (DSR2, 2, NotSerialized)
                    {
                        CreateWordField (Arg0, 0x11, IRQT)
                        CreateByteField (Arg0, 0x14, DMAT)
                        CreateWordField (Arg0, 0x02, IOT1)
                        CreateWordField (Arg0, 0x0A, IOT2)
                        ENFG (CGLD (Arg1))
                        And (IOT1, 0xFF, IOAL)
                        ShiftRight (IOT1, 0x08, IOAH)
                        And (IOT2, 0xFF, IOL2)
                        ShiftRight (IOT2, 0x08, IOH2)
                        If (IRQT)
                        {
                            FindSetRightBit (IRQT, Local0)
                            Subtract (Local0, One, INTR)
                        }
                        Else
                        {
                            Store (Zero, INTR)
                        }
                        If (DMAT)
                        {
                            FindSetRightBit (DMAT, Local0)
                            Subtract (Local0, One, DMCH)
                        }
                        Else
                        {
                            Store (0x04, DMCH)
                        }
                        EXFG ()
                        DCNT (Arg1, One)
                        Store (Arg1, Local2)
                        If (LGreater (Local2, Zero))
                        {
                            Subtract (Local2, One, Local2)
                        }
                    }
                    Method (DSR4, 2, NotSerialized)
                    {
                        CreateWordField (Arg0, 0x02, IOHL)
                        CreateWordField (Arg0, 0x09, IRQL)
                        ENFG (CGLD (Arg1))
                        And (IOHL, 0xFF, IOAL)
                        ShiftRight (IOHL, 0x08, IOAH)
                        If (IRQL)
                        {
                            FindSetRightBit (IRQL, Local0)
                            Subtract (Local0, One, INTR)
                        }
                        Else
                        {
                            Store (Zero, INTR)
                        }
                        EXFG ()
                        DCNT (Arg1, One)
                        Store (Arg1, Local2)
                        If (LGreater (Local2, Zero))
                        {
                            Subtract (Local2, One, Local2)
                        }
                    }
                }
                Name (PMFG, Zero)
                Method (SIOS, 1, NotSerialized)
                {
                    Store ("SIOS", Debug)
                    If (LNotEqual (0x05, Arg0))
                    {
                        ^SIO1.ENFG (0x04)
                        If (KBFG)
                        {
                            Or (^SIO1.OPT0, 0x08, ^SIO1.OPT0)
                        }
                        Else
                        {
                            And (^SIO1.OPT0, 0xF7, ^SIO1.OPT0)
                        }
                        If (MSFG)
                        {
                            Or (^SIO1.OPT0, 0x10, ^SIO1.OPT0)
                        }
                        Else
                        {
                            And (^SIO1.OPT0, 0xEF, ^SIO1.OPT0)
                        }
                        Store (0xFF, ^SIO1.OPT1)
                        And (0xBF, ^SIO1.OPT2, Local0)
                        Store (Local0, ^SIO1.OPT2)
                        Store (0x06, ^SIO1.LDN)
                        Store (Zero, ^SIO1.ACTR)
                        Store (0x05, ^SIO1.LDN)
                        Store (Zero, ^SIO1.ACTR)
                        ^SIO1.EXFG ()
                    }
                }
                Method (SIOW, 1, NotSerialized)
                {
                    Store ("SIOW", Debug)
                    ^SIO1.ENFG (0x04)
                    Store (^SIO1.OPT1, PMFG)
                    Store (0xFF, ^SIO1.OPT1)
                    And (^SIO1.OPT0, 0xE7, ^SIO1.OPT0)
                    Or (0x40, ^SIO1.OPT2, Local0)
                    Store (Local0, ^SIO1.OPT2)
                    Store (0x06, ^SIO1.LDN)
                    Store (One, ^SIO1.ACTR)
                    Store (0x05, ^SIO1.LDN)
                    Store (One, ^SIO1.ACTR)
                    ^SIO1.EXFG ()
                }
                Method (SIOH, 0, NotSerialized)
                {
                    If (And (PMFG, 0x08))
                    {
                        Notify (PS2K, 0x02)
                    }
                    If (And (PMFG, 0x10))
                    {
                        Notify (PS2M, 0x02)
                    }
                }
                Device (EC0)
                {
                    Name (_HID, EisaId ("PNP0C09"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0062,             // Range Minimum
                            0x0062,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            _Y21)
                        IO (Decode16,
                            0x0066,             // Range Minimum
                            0x0066,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            _Y22)
                    })
                    CreateWordField (_CRS, \_SB.PCI0.SBRG.EC0._Y21._MIN, DPRT)
                    CreateWordField (_CRS, \_SB.PCI0.SBRG.EC0._Y22._MIN, CPRT)
                    Name (_GPE, 0x0A)
                    Name (REGC, Zero)
                    Method (_Q80, 0, NotSerialized)
                    {
                        \AMW0.AMWN (0x05)
                    }
                    Method (_Q81, 0, NotSerialized)
                    {
                        \AMW0.AMWN (0x00010005)
                    }
                    Method (_Q82, 0, NotSerialized)
                    {
                        \AMW0.AMWN (0x00020005)
                    }
                    Method (_Q83, 0, NotSerialized)
                    {
                        \AMW0.AMWN (0x00030005)
                    }
                }
                Device (PIC)
                {
                    Name (_HID, EisaId ("PNP0000"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0020,             // Range Minimum
                            0x0020,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x00A0,             // Range Minimum
                            0x00A0,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IRQNoFlags ()
                            {2}
                    })
                }
                Device (DMAD)
                {
                    Name (_HID, EisaId ("PNP0200"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        DMA (Compatibility, BusMaster, Transfer8, )
                            {4}
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x0081,             // Range Minimum
                            0x0081,             // Range Maximum
                            0x00,               // Alignment
                            0x03,               // Length
                            )
                        IO (Decode16,
                            0x0087,             // Range Minimum
                            0x0087,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0089,             // Range Minimum
                            0x0089,             // Range Maximum
                            0x00,               // Alignment
                            0x03,               // Length
                            )
                        IO (Decode16,
                            0x008F,             // Range Minimum
                            0x008F,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x00C0,             // Range Minimum
                            0x00C0,             // Range Maximum
                            0x00,               // Alignment
                            0x20,               // Length
                            )
                    })
                }
                Device (TMR)
                {
                    Name (_HID, EisaId ("PNP0100"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0040,             // Range Minimum
                            0x0040,             // Range Maximum
                            0x00,               // Alignment
                            0x04,               // Length
                            )
                        IRQNoFlags ()
                            {0}
                    })
                }
                Device (RTC0)
                {
                    Name (_HID, EisaId ("PNP0B00"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0070,             // Range Minimum
                            0x0070,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IRQNoFlags ()
                            {8}
                    })
                }
                Device (SPKR)
                {
                    Name (_HID, EisaId ("PNP0800"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0061,             // Range Minimum
                            0x0061,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                    })
                }
                Scope (\_SB)
                {
                    Scope (PCI0)
                    {
                        Scope (SBRG)
                        {
                            Method (RRIO, 4, NotSerialized)
                            {
                                Store ("RRIO", Debug)
                            }
                            Method (RDMA, 3, NotSerialized)
                            {
                                Store ("rDMA", Debug)
                            }
                        }
                    }
                }
                Device (RMSC)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Name (_UID, 0x10)
                    Name (CRS1, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0010,             // Range Minimum
                            0x0010,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x0022,             // Range Minimum
                            0x0022,             // Range Maximum
                            0x00,               // Alignment
                            0x1E,               // Length
                            )
                        IO (Decode16,
                            0x0044,             // Range Minimum
                            0x0044,             // Range Maximum
                            0x00,               // Alignment
                            0x1C,               // Length
                            )
                        IO (Decode16,
                            0x0062,             // Range Minimum
                            0x0062,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0065,             // Range Minimum
                            0x0065,             // Range Maximum
                            0x00,               // Alignment
                            0x0B,               // Length
                            )
                        IO (Decode16,
                            0x0072,             // Range Minimum
                            0x0072,             // Range Maximum
                            0x00,               // Alignment
                            0x0E,               // Length
                            )
                        IO (Decode16,
                            0x0080,             // Range Minimum
                            0x0080,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0084,             // Range Minimum
                            0x0084,             // Range Maximum
                            0x00,               // Alignment
                            0x03,               // Length
                            )
                        IO (Decode16,
                            0x0088,             // Range Minimum
                            0x0088,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x008C,             // Range Minimum
                            0x008C,             // Range Maximum
                            0x00,               // Alignment
                            0x03,               // Length
                            )
                        IO (Decode16,
                            0x0090,             // Range Minimum
                            0x0090,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x00A2,             // Range Minimum
                            0x00A2,             // Range Maximum
                            0x00,               // Alignment
                            0x1E,               // Length
                            )
                        IO (Decode16,
                            0x00E0,             // Range Minimum
                            0x00E0,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x04D0,             // Range Minimum
                            0x04D0,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                    })
                    Name (CRS2, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0010,             // Range Minimum
                            0x0010,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x0022,             // Range Minimum
                            0x0022,             // Range Maximum
                            0x00,               // Alignment
                            0x1E,               // Length
                            )
                        IO (Decode16,
                            0x0044,             // Range Minimum
                            0x0044,             // Range Maximum
                            0x00,               // Alignment
                            0x1C,               // Length
                            )
                        IO (Decode16,
                            0x0072,             // Range Minimum
                            0x0072,             // Range Maximum
                            0x00,               // Alignment
                            0x0E,               // Length
                            )
                        IO (Decode16,
                            0x0080,             // Range Minimum
                            0x0080,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0084,             // Range Minimum
                            0x0084,             // Range Maximum
                            0x00,               // Alignment
                            0x03,               // Length
                            )
                        IO (Decode16,
                            0x0088,             // Range Minimum
                            0x0088,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x008C,             // Range Minimum
                            0x008C,             // Range Maximum
                            0x00,               // Alignment
                            0x03,               // Length
                            )
                        IO (Decode16,
                            0x0090,             // Range Minimum
                            0x0090,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x00A2,             // Range Minimum
                            0x00A2,             // Range Maximum
                            0x00,               // Alignment
                            0x1E,               // Length
                            )
                        IO (Decode16,
                            0x00E0,             // Range Minimum
                            0x00E0,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x04D0,             // Range Minimum
                            0x04D0,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        If (And (MBEC, 0xFFFF))
                        {
                            Return (CRS1)
                        }
                        Else
                        {
                            Return (CRS2)
                        }
                    }
                }
                Device (COPR)
                {
                    Name (_HID, EisaId ("PNP0C04"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x00F0,             // Range Minimum
                            0x00F0,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IRQNoFlags ()
                            {13}
                    })
                }
                Device (NBRM)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Name (_UID, 0x99)
                    Name (CRS, ResourceTemplate ()
                    {
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        Return (CRS)
                    }
                }
                Device (PS2K)
                {
                    Name (_HID, EisaId ("PNP0303"))
                    Name (_CID, EisaId ("PNP030B"))
                    Method (_STA, 0, NotSerialized)
                    {
                        If (And (IOST, 0x0400))
                        {
                            Return (0x0F)
                        }
                        Else
                        {
                            Return (Zero)
                        }
                    }
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0060,             // Range Minimum
                            0x0060,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0064,             // Range Minimum
                            0x0064,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IRQNoFlags ()
                            {1}
                    })
                    Name (_PRS, ResourceTemplate ()
                    {
                        StartDependentFn (0x00, 0x00)
                        {
                            FixedIO (
                                0x0060,             // Address
                                0x01,               // Length
                                )
                            FixedIO (
                                0x0064,             // Address
                                0x01,               // Length
                                )
                            IRQNoFlags ()
                                {1}
                        }
                        EndDependentFn ()
                    })
                    Method (_PSW, 1, NotSerialized)
                    {
                        Store (Arg0, KBFG)
                    }
                }
                Scope (\)
                {
                    Name (KBFG, One)
                }
                Method (PS2K._PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x03, 0x03))
                }
                Device (PS2M)
                {
                    Name (_HID, EisaId ("PNP0F03"))
                    Name (_CID, EisaId ("PNP0F13"))
                    Method (_STA, 0, NotSerialized)
                    {
                        If (And (IOST, 0x4000))
                        {
                            Return (0x0F)
                        }
                        Else
                        {
                            Return (Zero)
                        }
                    }
                    Name (CRS1, ResourceTemplate ()
                    {
                        IRQNoFlags ()
                            {12}
                    })
                    Name (CRS2, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0060,             // Range Minimum
                            0x0060,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0064,             // Range Minimum
                            0x0064,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IRQNoFlags ()
                            {12}
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        If (And (IOST, 0x0400))
                        {
                            Return (CRS1)
                        }
                        Else
                        {
                            Return (CRS2)
                        }
                    }
                    Name (_PRS, ResourceTemplate ()
                    {
                        StartDependentFn (0x00, 0x00)
                        {
                            IRQNoFlags ()
                                {12}
                        }
                        EndDependentFn ()
                    })
                    Method (_PSW, 1, NotSerialized)
                    {
                        Store (Arg0, MSFG)
                    }
                }
                Scope (\)
                {
                    Name (MSFG, One)
                }
                Method (PS2M._PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x03, 0x03))
                }
                Scope (^^PCI0)
                {
                    Name (SLIC, Buffer (0x9E)
                    {
                        "847339457828Genuine NVIDIA Certified SLI Ready Motherboard for ASUS CROSSHAIR V FOR8426-Copyright 2011 NVIDIA Corporation All Rights Reserved-948502369474(R)"
                    })
                    Name (SLI4, Buffer (0x9E)
                    {
                        "987134512781Genuine NVIDIA Certified SLI Ready Motherboard for ASUS ROG XPANDER    4458-Copyright 2008 NVIDIA Corporation All Rights Reserved-765289891023(R)"
                    })
                    Device (WMI1)
                    {
                        Name (_HID, "PNP0c14")
                        Name (_UID, "MXM2")
                        Name (_WDG, Buffer (0x14)
                        {
                            /* 0000 */   0x3C, 0x5C, 0xCB, 0xF6, 0xAE, 0x9C, 0xBD, 0x4E,
                            /* 0008 */   0xB5, 0x77, 0x93, 0x1E, 0xA3, 0x2A, 0x2C, 0xC0,
                            /* 0010 */   0x4D, 0x58, 0x01, 0x02
                        })
                        Method (WMMX, 3, NotSerialized)
                        {
                            CreateDWordField (Arg2, Zero, FUNC)
                            If (LEqual (FUNC, 0x41494C53))
                            {
                                If (LEqual (R2YT (0x92, 0x8C), 0xFF))
                                {
                                    Return (SLIC)
                                }
                                Else
                                {
                                    Return (SLI4)
                                }
                            }
                            Return (Zero)
                        }
                    }
                }
            }
            Device (P0PC)
            {
                Name (_ADR, 0x00140004)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x04, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR0C)
                    }
                    Return (PR0C)
                }
            }
            Device (UHC1)
            {
                Name (_ADR, 0x00120000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x0B, 0x04))
                }
            }
            Device (UHC2)
            {
                Name (_ADR, 0x00120002)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x0B, 0x04))
                }
            }
            Device (USB3)
            {
                Name (_ADR, 0x00130000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x0B, 0x04))
                }
            }
            Device (UHC4)
            {
                Name (_ADR, 0x00130002)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x0B, 0x04))
                }
            }
            Device (USB5)
            {
                Name (_ADR, 0x00160000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x0B, 0x04))
                }
            }
            Device (UHC6)
            {
                Name (_ADR, 0x00160002)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x0B, 0x04))
                }
            }
            Device (UHC7)
            {
                Name (_ADR, 0x00140005)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x0B, 0x04))
                }
            }
            Device (SATA)
            {
                Name (_ADR, 0x00110000)
                Method (_INI, 0, NotSerialized)
                {
                }
                OperationRegion (SACS, PCI_Config, Zero, 0x40)
                Field (SACS, AnyAcc, NoLock, Preserve)
                {
                    Offset (0x24), 
                    STB5,   32
                }
                Name (SPTM, Buffer (0x14)
                {
                    /* 0000 */   0x78, 0x00, 0x00, 0x00, 0x0F, 0x00, 0x00, 0x00,
                    /* 0008 */   0x78, 0x00, 0x00, 0x00, 0x0F, 0x00, 0x00, 0x00,
                    /* 0010 */   0x1F, 0x00, 0x00, 0x00
                })
                Device (PRID)
                {
                    Name (_ADR, Zero)
                    Method (_GTM, 0, NotSerialized)
                    {
                        Return (SPTM)
                    }
                    Method (_STM, 3, NotSerialized)
                    {
                    }
                    Method (_STA, 0, NotSerialized)
                    {
                        If (LEqual (STCL, 0x0101))
                        {
                            Store (0x0F, Local1)
                        }
                        Else
                        {
                            Store (Zero, Local1)
                        }
                        Return (Local1)
                    }
                    Name (PRIS, Zero)
                    Method (_PS0, 0, NotSerialized)
                    {
                        OperationRegion (BAR, SystemMemory, STB5, 0x0400)
                        Field (BAR, AnyAcc, NoLock, Preserve)
                        {
                            Offset (0x120), 
                                ,   7, 
                            PMBY,   1, 
                            Offset (0x128), 
                            PMS0,   4, 
                            Offset (0x129), 
                            PMS1,   4, 
                            Offset (0x220), 
                                ,   7, 
                            PSBY,   1, 
                            Offset (0x228), 
                            PSS0,   4, 
                            Offset (0x229), 
                            PSS1,   4, 
                            Offset (0x2A0), 
                                ,   7
                        }
                        If (LOr (LEqual (OSTY, 0x06), LEqual (OSTY, 0x04)))
                        {
                            If (PMS1)
                            {
                                Store (0x32, Local0)
                                While (LAnd (LEqual (PMBY, One), Local0))
                                {
                                    Sleep (0xFA)
                                    Decrement (Local0)
                                }
                            }
                            If (PSS1)
                            {
                                Store (0x32, Local0)
                                While (LAnd (LEqual (PSBY, One), Local0))
                                {
                                    Sleep (0xFA)
                                    Decrement (Local0)
                                }
                            }
                        }
                        Store (Zero, PRIS)
                    }
                    Method (_PS3, 0, NotSerialized)
                    {
                        Store (0x03, PRIS)
                    }
                    Method (_PSC, 0, NotSerialized)
                    {
                        Return (PRIS)
                    }
                    Device (P_D0)
                    {
                        Name (_ADR, Zero)
                        Method (_STA, 0, NotSerialized)
                        {
                            OperationRegion (BAR, SystemMemory, STB5, 0x0400)
                            Field (BAR, AnyAcc, NoLock, Preserve)
                            {
                                Offset (0x128), 
                                PMS0,   4, 
                                Offset (0x129), 
                                PMS1,   4
                            }
                            If (Not (LEqual (PMS1, Zero)))
                            {
                                Return (0x0F)
                            }
                            Else
                            {
                                Return (Zero)
                            }
                        }
                        Name (S12P, Zero)
                        Method (_PS0, 0, NotSerialized)
                        {
                            OperationRegion (BAR, SystemMemory, STB5, 0x0400)
                            Field (BAR, AnyAcc, NoLock, Preserve)
                            {
                                Offset (0x120), 
                                    ,   7, 
                                PMBY,   1
                            }
                            Store (0x32, Local0)
                            While (LAnd (LEqual (PMBY, One), Local0))
                            {
                                Sleep (0xFA)
                                Decrement (Local0)
                            }
                            Store (Zero, S12P)
                        }
                        Method (_PS3, 0, NotSerialized)
                        {
                            Store (0x03, S12P)
                        }
                        Method (_PSC, 0, NotSerialized)
                        {
                            Return (S12P)
                        }
                    }
                    Device (P_D1)
                    {
                        Name (_ADR, One)
                        Method (_STA, 0, NotSerialized)
                        {
                            OperationRegion (BAR, SystemMemory, STB5, 0x0400)
                            Field (BAR, AnyAcc, NoLock, Preserve)
                            {
                                Offset (0x228), 
                                PSS0,   4, 
                                Offset (0x229), 
                                PSS1,   4
                            }
                            If (Not (LEqual (PSS1, Zero)))
                            {
                                Return (0x0F)
                            }
                            Else
                            {
                                Return (Zero)
                            }
                        }
                        Name (S12P, Zero)
                        Method (_PS0, 0, NotSerialized)
                        {
                            OperationRegion (BAR, SystemMemory, STB5, 0x0400)
                            Field (BAR, AnyAcc, NoLock, Preserve)
                            {
                                Offset (0x220), 
                                    ,   7, 
                                PSBY,   1
                            }
                            Store (0x32, Local0)
                            While (LAnd (LEqual (PSBY, One), Local0))
                            {
                                Sleep (0xFA)
                                Decrement (Local0)
                            }
                            Store (Zero, S12P)
                        }
                        Method (_PS3, 0, NotSerialized)
                        {
                            Store (0x03, S12P)
                        }
                        Method (_PSC, 0, NotSerialized)
                        {
                            Return (S12P)
                        }
                    }
                }
                Device (SECD)
                {
                    Name (_ADR, One)
                    Method (_GTM, 0, NotSerialized)
                    {
                        Return (SPTM)
                    }
                    Method (_STM, 3, NotSerialized)
                    {
                    }
                    Name (SECS, Zero)
                    Method (_STA, 0, NotSerialized)
                    {
                        If (LEqual (STCL, 0x0101))
                        {
                            Store (0x0F, Local1)
                        }
                        Else
                        {
                            Store (Zero, Local1)
                        }
                        Return (Local1)
                    }
                    Method (_PS0, 0, NotSerialized)
                    {
                        OperationRegion (BAR, SystemMemory, STB5, 0x0400)
                        Field (BAR, AnyAcc, NoLock, Preserve)
                        {
                            Offset (0x1A0), 
                                ,   7, 
                            SMBY,   1, 
                            Offset (0x1A8), 
                            SMS0,   4, 
                            Offset (0x1A9), 
                            SMS1,   4, 
                            Offset (0x2A0), 
                                ,   7, 
                            SSBY,   1, 
                            Offset (0x2A8), 
                            SSS0,   4, 
                            Offset (0x2A9), 
                            SSS1,   4, 
                            Offset (0x2AC)
                        }
                        If (LOr (LEqual (OSTY, 0x06), LEqual (OSTY, 0x04)))
                        {
                            If (SMS1)
                            {
                                Store (0x32, Local0)
                                While (LAnd (LEqual (SMBY, One), Local0))
                                {
                                    Sleep (0xFA)
                                    Decrement (Local0)
                                }
                            }
                            If (SSS1)
                            {
                                Store (0x32, Local0)
                                While (LAnd (LEqual (SSBY, One), Local0))
                                {
                                    Sleep (0xFA)
                                    Decrement (Local0)
                                }
                            }
                        }
                        Store (Zero, SECS)
                    }
                    Method (_PS3, 0, NotSerialized)
                    {
                        Store (0x03, SECS)
                    }
                    Method (_PSC, 0, NotSerialized)
                    {
                        Return (SECS)
                    }
                    Device (S_D0)
                    {
                        Name (_ADR, Zero)
                        Method (_STA, 0, NotSerialized)
                        {
                            OperationRegion (BAR, SystemMemory, STB5, 0x0400)
                            Field (BAR, AnyAcc, NoLock, Preserve)
                            {
                                Offset (0x1A8), 
                                SMS0,   4, 
                                Offset (0x1A9), 
                                SMS1,   4
                            }
                            If (Not (LEqual (SMS1, Zero)))
                            {
                                Return (0x0F)
                            }
                            Else
                            {
                                Return (Zero)
                            }
                        }
                        Name (S12P, Zero)
                        Method (_PS0, 0, NotSerialized)
                        {
                            OperationRegion (BAR, SystemMemory, STB5, 0x1000)
                            Field (BAR, AnyAcc, NoLock, Preserve)
                            {
                                Offset (0x1A0), 
                                    ,   7, 
                                SMBY,   1
                            }
                            Store (0x32, Local0)
                            While (LAnd (LEqual (SMBY, One), Local0))
                            {
                                Sleep (0xFA)
                                Decrement (Local0)
                            }
                            Store (Zero, S12P)
                        }
                        Method (_PS3, 0, NotSerialized)
                        {
                            Store (0x03, S12P)
                        }
                        Method (_PSC, 0, NotSerialized)
                        {
                            Return (S12P)
                        }
                    }
                    Device (S_D1)
                    {
                        Name (_ADR, One)
                        Method (_STA, 0, NotSerialized)
                        {
                            OperationRegion (BAR, SystemMemory, STB5, 0x0400)
                            Field (BAR, AnyAcc, NoLock, Preserve)
                            {
                                Offset (0x2A8), 
                                SSS0,   4, 
                                Offset (0x2A9), 
                                SSS1,   4
                            }
                            If (Not (LEqual (SSS1, Zero)))
                            {
                                Return (0x0F)
                            }
                            Else
                            {
                                Return (Zero)
                            }
                        }
                        Name (S12P, Zero)
                        Method (_PS0, 0, NotSerialized)
                        {
                            OperationRegion (BAR, SystemMemory, STB5, 0x0400)
                            Field (BAR, AnyAcc, NoLock, Preserve)
                            {
                                Offset (0x2A0), 
                                    ,   7, 
                                SSBY,   1
                            }
                            Store (0x32, Local0)
                            While (LAnd (LEqual (SSBY, One), Local0))
                            {
                                Sleep (0xFA)
                                Decrement (Local0)
                            }
                            Store (Zero, S12P)
                        }
                        Method (_PS3, 0, NotSerialized)
                        {
                            Store (0x03, S12P)
                        }
                        Method (_PSC, 0, NotSerialized)
                        {
                            Return (S12P)
                        }
                    }
                }
            }
            Device (PE20)
            {
                Name (_ADR, 0x00150000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x0F, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR20)
                    }
                    Return (PR20)
                }
            }
            Device (PE21)
            {
                Name (_ADR, 0x00150001)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x10, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR21)
                    }
                    Return (PR21)
                }
            }
            Device (PE22)
            {
                Name (_ADR, 0x00150002)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x11, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR22)
                    }
                    Return (PR22)
                }
            }
            Device (PE23)
            {
                Name (_ADR, 0x00150003)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x12, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR23)
                    }
                    Return (PR23)
                }
            }
            Device (IOMA)
            {
                Name (_ADR, 0x02)
                OperationRegion (NBF2, PCI_Config, Zero, 0x0100)
                Field (NBF2, AnyAcc, NoLock, Preserve)
                {
                    DID,    32, 
                    Offset (0x44), 
                    MBAS,   32
                }
                Device (UMEM)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Name (_UID, 0x15)
                    Name (CRS, ResourceTemplate ()
                    {
                        Memory32Fixed (ReadOnly,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y23)
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        CreateDWordField (CRS, \_SB.PCI0.IOMA.UMEM._Y23._BAS, BAS3)
                        CreateDWordField (CRS, \_SB.PCI0.IOMA.UMEM._Y23._LEN, LEN3)
                        If (LNotEqual (DID, 0xFFFFFFFF))
                        {
                            Store (0x4000, LEN3)
                            And (MBAS, 0xFFFFFF00, BAS3)
                        }
                        Return (CRS)
                    }
                }
            }
            Device (RD8A)
            {
                Name (_ADR, Zero)
                OperationRegion (NB2, PCI_Config, Zero, 0x0100)
                Field (NB2, AnyAcc, NoLock, Preserve)
                {
                    Offset (0x60), 
                    MI,     32, 
                    MD,     32, 
                    Offset (0x94), 
                    HI,     32, 
                    HD,     32, 
                    Offset (0xF8), 
                    API,    32, 
                    APD,    32
                }
                Device (NMEM)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Name (_UID, 0x14)
                    Name (CRS, ResourceTemplate ()
                    {
                        Memory32Fixed (ReadOnly,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y24)
                        Memory32Fixed (ReadOnly,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y25)
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        CreateDWordField (CRS, \_SB.PCI0.RD8A.NMEM._Y24._BAS, BAS1)
                        CreateDWordField (CRS, \_SB.PCI0.RD8A.NMEM._Y24._LEN, LEN1)
                        Store (0x3C, MI)
                        Store (MD, Local0)
                        If (And (Local0, 0x40))
                        {
                            Store (0x3A, MI)
                            And (MD, 0xFFFFFF00, BAS1)
                            ShiftLeft (And (MD, 0xFF), 0x17, LEN1)
                        }
                        CreateDWordField (CRS, \_SB.PCI0.RD8A.NMEM._Y25._BAS, BAS2)
                        CreateDWordField (CRS, \_SB.PCI0.RD8A.NMEM._Y25._LEN, LEN2)
                        Store (Zero, API)
                        Store (APD, Local1)
                        If (And (Local1, One))
                        {
                            Store (0x0100, LEN2)
                            Store (One, API)
                            And (APD, 0xFFFFFF00, BAS2)
                        }
                        Return (CRS)
                    }
                }
            }
            Device (PC02)
            {
                Name (_ADR, 0x00020000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x18, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR12)
                    }
                    Return (PR12)
                }
            }
            Device (PC04)
            {
                Name (_ADR, 0x00040000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x18, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR14)
                    }
                    Return (PR14)
                }
            }
            Device (PC05)
            {
                Name (_ADR, 0x00050000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x18, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR15)
                    }
                    Return (PR15)
                }
            }
            Device (PC06)
            {
                Name (_ADR, 0x00060000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x18, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR16)
                    }
                    Return (PR16)
                }
            }
            Device (PC07)
            {
                Name (_ADR, 0x00070000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x18, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR17)
                    }
                    Return (PR17)
                }
            }
            Device (PC09)
            {
                Name (_ADR, 0x00090000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x18, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR19)
                    }
                    Return (PR19)
                }
            }
            Device (PC0A)
            {
                Name (_ADR, 0x000A0000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x18, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR1A)
                    }
                    Return (PR1A)
                }
            }
            Device (PC0B)
            {
                Name (_ADR, 0x000B0000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x18, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR1B)
                    }
                    Return (PR1B)
                }
            }
            Device (PC0C)
            {
                Name (_ADR, 0x000C0000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x18, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR1C)
                    }
                    Return (PR1C)
                }
            }
            Device (PC0D)
            {
                Name (_ADR, 0x000D0000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x18, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR1D)
                    }
                    Return (PR1D)
                }
            }
            Device (SBUS)
            {
                Name (_ADR, 0x001F0003)
                Device (BUS0)
                {
                    Name (_CID, "smbus")
                    Name (_ADR, Zero)
                    Device (DVL0)
                    {
                        Name (_ADR, 0x57)
                        Name (_CID, "diagsvault")
                    }
                }
                Method (_DSM, 4, NotSerialized)
                {
                    Store (Package (0x02)
                        {
                            "device-id", 
                            Buffer (0x04)
                            {
                                0x30, 0x3A, 0x00, 0x00
                            }
                        }, Local0)
                    DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                    Return (Local0)
                }
            }
                        Device (PEG1)
                        {
                            Name (_ADR, 0x00010000)
                            Method (_PRW, 0, NotSerialized)
                            {
                                Return (Package (0x02)
                                {
                                    0x0B,
                                    0x04
                                })
                            }
                Device (GFX0)
                {
                    Name (_ADR, Zero)	
                    Name (_SUN, One)
                    Method (_DSM, 4, NotSerialized)
                    {
                        Store (Package (0x1E)
                            {
                                "AAPL,slot-name", 
                                "PCI x16", 
                                "@0,compatible", 
                                Buffer (0x0B)
                                {
                                    "NVDA,NVMac"
                                }, 
                                "@0,connector-type", 
                                Buffer (0x04)
                                {
                                     0x00, 0x08, 0x00, 0x00
                                }, 
                                "@0,device_type", 
                                Buffer (0x08)
                                {
                                    "display"
                                }, 
                                "@0,name", 
                                Buffer (0x0F)
                                {
                                    "NVDA,Display-A"
                                }, 
                                "@1,compatible", 
                                Buffer (0x0B)
                                {
                                    "NVDA,NVMac"
                                }, 
                                "@1,connector-type", 
                                Buffer (0x04)
                                {
                                     0x00, 0x08, 0x00, 0x00
                                }, 
                                "@1,device_type", 
                                Buffer (0x08)
                                {
                                    "display"
                                }, 
                                "@1,name", 
                                Buffer (0x0F)
                                {
                                    "NVDA,Display-B"
                                }, 
                                "NVCAP", 
                                Buffer (0x18)
                                {
                                    /* 0000 */   0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00,
                                    /* 0008 */   0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0A,
                                    /* 0010 */   0x00, 0x00, 0x00, 0x00
                                }, 
                                "VRAM,totalsize", 
                                Buffer (0x04)
                                {
                                     0x00, 0x00, 0x00, 0x80
                                }, 
                                "device_type", 
                                Buffer (0x0C)
                                {
                                    "NVDA,Parent"
                                }, 
                                "model", 
                                Buffer (0x10)
                                {
                                    "GeForce GTX 670"
                                }, 
                                "rom-revision", 
                                Buffer (0x1D)
                                {
                                    "nVidia GTX 670 OpenGL Engine"
                                }, 
                                "hda-gfx", 
                                Buffer (0x0A)
                                {
                                    "onboard-1"
                                }
                            }, Local0)
                        DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                        Return (Local0)
                    }
                }
                Device (HDAU)
                {
                    Name (_ADR, One)
                    Method (_DSM, 4, NotSerialized)
                    {
                        Store (Package (0x02)
                            {
                                "hda-gfx", 
                                Buffer (0x0A)
                                {
                                    "onboard-1"
                                }
                            }, Local0)
                        DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                        Return (Local0)
                    }
                }
            }
        }
        Scope (\_GPE)
        {
            Method (_L1B, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.SBAZ, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }
            Method (_L03, 0, NotSerialized)
            {
                \_SB.PCI0.SBRG.SIOH ()
                Notify (\_SB.PWRB, 0x02)
            }
            Method (_L04, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.P0PC, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }
            Method (_L0B, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.UHC1, 0x02)
                Notify (\_SB.PCI0.UHC2, 0x02)
                Notify (\_SB.PCI0.USB3, 0x02)
                Notify (\_SB.PCI0.UHC4, 0x02)
                Notify (\_SB.PCI0.USB5, 0x02)
                Notify (\_SB.PCI0.UHC6, 0x02)
                Notify (\_SB.PCI0.UHC7, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }
            Method (_L0F, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.PE20, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }
            Method (_L10, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.PE21, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }
            Method (_L11, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.PE22, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }
            Method (_L12, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.PE23, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }
            Method (_L18, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.PC02, 0x02)
                Notify (\_SB.PCI0.PC04, 0x02)
                Notify (\_SB.PCI0.PC05, 0x02)
                Notify (\_SB.PCI0.PC06, 0x02)
                Notify (\_SB.PCI0.PC07, 0x02)
                Notify (\_SB.PCI0.PC09, 0x02)
                Notify (\_SB.PCI0.PC0A, 0x02)
                Notify (\_SB.PCI0.PC0B, 0x02)
                Notify (\_SB.PCI0.PC0C, 0x02)
                Notify (\_SB.PCI0.PC0D, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }
        }
        Device (PWRB)
        {
            Name (_HID, EisaId ("PNP0C0C"))
            Name (_UID, 0xAA)
            Name (_STA, 0x0B)
            Method (_PRW, 0, NotSerialized)
            {
                Return (GPRW (0x03, 0x03))
            }
        }
    }
    Scope (_SB)
    {
        OperationRegion (PIRQ, SystemIO, 0x0C00, 0x02)
        Field (PIRQ, ByteAcc, NoLock, Preserve)
        {
            PIDX,   8, 
            PDAT,   8
        }
        IndexField (PIDX, PDAT, ByteAcc, NoLock, Preserve)
        {
            PIRA,   8, 
            PIRB,   8, 
            PIRC,   8, 
            PIRD,   8, 
            PIRE,   8, 
            PIRF,   8, 
            PIRG,   8, 
            PIRH,   8, 
            Offset (0x10), 
            PIRS,   8, 
            Offset (0x13), 
            HDAD,   8, 
            Offset (0x15), 
            GEC,    8, 
            Offset (0x30), 
            USB1,   8, 
            USB2,   8, 
            USB3,   8, 
            USB4,   8, 
            USB5,   8, 
            USB6,   8, 
            USB7,   8, 
            Offset (0x40), 
            IDE,    8, 
            SATA,   8, 
            Offset (0x50), 
            GPP0,   8, 
            GPP1,   8, 
            GPP2,   8, 
            GPP3,   8
        }
        OperationRegion (KBDD, SystemIO, 0x64, One)
        Field (KBDD, ByteAcc, NoLock, Preserve)
        {
            PD64,   8
        }
        Method (IRQC, 0, NotSerialized)
        {
            INTA (0x1F)
            INTB (0x1F)
            INTC (0x1F)
            INTD (0x1F)
            Store (PD64, Local1)
            Store (0x1F, PIRE)
            Store (0x1F, PIRF)
            Store (0x1F, PIRG)
            Store (0x1F, PIRH)
        }
        Method (INTA, 1, NotSerialized)
        {
            Store (Arg0, PIRA)
            Store (Arg0, HDAD)
            Store (Arg0, GEC)
            Store (Arg0, GPP0)
            Store (Arg0, GPP0)
        }
        Method (INTB, 1, NotSerialized)
        {
            Store (Arg0, PIRB)
            Store (Arg0, USB2)
            Store (Arg0, USB4)
            Store (Arg0, USB6)
            Store (Arg0, GPP1)
            Store (Arg0, IDE)
        }
        Method (INTC, 1, NotSerialized)
        {
            Store (Arg0, PIRC)
            Store (Arg0, USB1)
            Store (Arg0, USB3)
            Store (Arg0, USB5)
            Store (Arg0, USB7)
            Store (Arg0, GPP2)
        }
        Method (INTD, 1, NotSerialized)
        {
            Store (Arg0, PIRD)
            Store (Arg0, SATA)
            Store (Arg0, GPP3)
        }
        Name (BUFA, ResourceTemplate ()
        {
            IRQ (Level, ActiveLow, Shared, )
                {15}
        })
        Name (IPRA, ResourceTemplate ()
        {
            IRQ (Level, ActiveLow, Shared, )
                {5,10,11}
        })
        Name (IPRB, ResourceTemplate ()
        {
            IRQ (Level, ActiveLow, Shared, )
                {5,10,11}
        })
        Name (IPRC, ResourceTemplate ()
        {
            IRQ (Level, ActiveLow, Shared, )
                {5,10,11}
        })
        Name (IPRD, ResourceTemplate ()
        {
            IRQ (Level, ActiveLow, Shared, )
                {5,10,11}
        })
        Device (LNKA)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, One)
            Method (_STA, 0, NotSerialized)
            {
                If (PIRA)
                {
                    Return (0x0B)
                }
                Else
                {
                    Return (0x09)
                }
            }
            Method (_PRS, 0, NotSerialized)
            {
                Return (PRSA)
            }
            Method (_DIS, 0, NotSerialized)
            {
                INTA (0x1F)
            }
            Method (_CRS, 0, NotSerialized)
            {
                CreateWordField (BUFA, One, IRQX)
                ShiftLeft (One, PIRA, IRQX)
                Return (BUFA)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IRA)
                FindSetRightBit (IRA, Local0)
                Decrement (Local0)
                INTA (Local0)
            }
        }
        Device (LNKB)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x02)
            Method (_STA, 0, NotSerialized)
            {
                If (PIRB)
                {
                    Return (0x0B)
                }
                Else
                {
                    Return (0x09)
                }
            }
            Method (_PRS, 0, NotSerialized)
            {
                Return (PRSB)
            }
            Method (_DIS, 0, NotSerialized)
            {
                INTB (0x1F)
            }
            Method (_CRS, 0, NotSerialized)
            {
                CreateWordField (BUFA, One, IRQX)
                ShiftLeft (One, PIRB, IRQX)
                Return (BUFA)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IRA)
                FindSetRightBit (IRA, Local0)
                Decrement (Local0)
                INTB (Local0)
            }
        }
        Device (LNKC)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x03)
            Method (_STA, 0, NotSerialized)
            {
                If (PIRC)
                {
                    Return (0x0B)
                }
                Else
                {
                    Return (0x09)
                }
            }
            Method (_PRS, 0, NotSerialized)
            {
                Return (PRSC)
            }
            Method (_DIS, 0, NotSerialized)
            {
                INTC (0x1F)
            }
            Method (_CRS, 0, NotSerialized)
            {
                CreateWordField (BUFA, One, IRQX)
                ShiftLeft (One, PIRC, IRQX)
                Return (BUFA)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IRA)
                FindSetRightBit (IRA, Local0)
                Decrement (Local0)
                INTC (Local0)
            }
        }
        Device (LNKD)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x04)
            Method (_STA, 0, NotSerialized)
            {
                If (PIRD)
                {
                    Return (0x0B)
                }
                Else
                {
                    Return (0x09)
                }
            }
            Method (_PRS, 0, NotSerialized)
            {
                Return (PRSD)
            }
            Method (_DIS, 0, NotSerialized)
            {
                INTD (0x1F)
            }
            Method (_CRS, 0, NotSerialized)
            {
                CreateWordField (BUFA, One, IRQX)
                ShiftLeft (One, PIRD, IRQX)
                Return (BUFA)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IRA)
                FindSetRightBit (IRA, Local0)
                Decrement (Local0)
                INTD (Local0)
            }
        }
        Device (LNKE)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x05)
            Method (_STA, 0, NotSerialized)
            {
                If (PIRE)
                {
                    Return (0x0B)
                }
                Else
                {
                    Return (0x09)
                }
            }
            Method (_PRS, 0, NotSerialized)
            {
                Return (PRSE)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Store (0x1F, PIRE)
            }
            Method (_CRS, 0, NotSerialized)
            {
                CreateWordField (BUFA, One, IRQX)
                ShiftLeft (One, PIRE, IRQX)
                Return (BUFA)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IRA)
                FindSetRightBit (PIRE, Local0)
                Decrement (Local0)
                Store (Local0, PIRE)
            }
        }
        Device (LNKF)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x02)
            Method (_STA, 0, NotSerialized)
            {
                If (PIRF)
                {
                    Return (0x0B)
                }
                Else
                {
                    Return (0x09)
                }
            }
            Method (_PRS, 0, NotSerialized)
            {
                Return (PRSF)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Store (0x1F, PIRF)
            }
            Method (_CRS, 0, NotSerialized)
            {
                CreateWordField (BUFA, One, IRQX)
                ShiftLeft (One, PIRF, IRQX)
                Return (BUFA)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IRA)
                FindSetRightBit (IRA, Local0)
                Decrement (Local0)
                Store (Local0, PIRF)
            }
        }
        Device (LNKG)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x03)
            Method (_STA, 0, NotSerialized)
            {
                If (PIRG)
                {
                    Return (0x0B)
                }
                Else
                {
                    Return (0x09)
                }
            }
            Method (_PRS, 0, NotSerialized)
            {
                Return (PRSG)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Store (0x1F, PIRG)
            }
            Method (_CRS, 0, NotSerialized)
            {
                CreateWordField (BUFA, One, IRQX)
                ShiftLeft (One, PIRG, IRQX)
                Return (BUFA)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IRA)
                FindSetRightBit (IRA, Local0)
                Decrement (Local0)
                Store (Local0, PIRG)
            }
        }
        Device (LNKH)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x04)
            Method (_STA, 0, NotSerialized)
            {
                If (PIRH)
                {
                    Return (0x0B)
                }
                Else
                {
                    Return (0x09)
                }
            }
            Method (_PRS, 0, NotSerialized)
            {
                Return (PRSH)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Store (0x1F, PIRH)
            }
            Method (_CRS, 0, NotSerialized)
            {
                CreateWordField (BUFA, One, IRQX)
                ShiftLeft (One, PIRH, IRQX)
                Return (BUFA)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IRA)
                FindSetRightBit (IRA, Local0)
                Decrement (Local0)
                Store (Local0, PIRH)
            }
        }
    }
    Scope (_PR)
    {
        OperationRegion (SSDT, SystemMemory, 0xFFFF0000, 0xFFFF)
        Name (DCOR, 0x02)
        Name (TBLD, 0x04)
        Name (NPSS, 0x05)
        Name (HNDL, 0x80000000)
        Name (APSS, Package (0x0A)
        {
            Package (0x06)
            {
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF
            }, 
            Package (0x06)
            {
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF
            }, 
            Package (0x06)
            {
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF
            }, 
            Package (0x06)
            {
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF
            }, 
            Package (0x06)
            {
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF
            }, 
            Package (0x06)
            {
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF
            }, 
            Package (0x06)
            {
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF
            }, 
            Package (0x06)
            {
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF
            }, 
            Package (0x06)
            {
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF
            }, 
            Package (0x06)
            {
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF, 
                0xFFFF
            }
        })
        Processor (P001, 0x01, 0x00000810, 0x06)
        {
            Name (TYPE, 0x80000000)
            Method (_PDC, 1, NotSerialized)
            {
                CreateDWordField (Arg0, 0x08, DAT0)
                Store (DAT0, TYPE)
                If (LAnd (LEqual (TBLD, Zero), LNotEqual (NPSS, Zero)))
                {
                    If (LOr (LEqual (And (TYPE, 0x1B), 0x1B), LEqual (DCOR, 
                        Zero)))
                    {
                        Store (One, TBLD)
                        Load (SSDT, HNDL)
                    }
                }
            }
        }
        Processor (P002, 0x02, 0x00000810, 0x06)
        {
            Name (TYPE, 0x80000000)
            Method (_PDC, 1, NotSerialized)
            {
                CreateDWordField (Arg0, 0x08, DAT0)
                Store (DAT0, TYPE)
                If (LAnd (LEqual (TBLD, Zero), LNotEqual (NPSS, Zero)))
                {
                    If (LOr (LEqual (And (TYPE, 0x1B), 0x1B), LEqual (DCOR, 
                        Zero)))
                    {
                        Store (One, TBLD)
                        Load (SSDT, HNDL)
                    }
                }
            }
        }
        Processor (P003, 0x03, 0x00000810, 0x06)
        {
            Name (TYPE, 0x80000000)
            Method (_PDC, 1, NotSerialized)
            {
                CreateDWordField (Arg0, 0x08, DAT0)
                Store (DAT0, TYPE)
                If (LAnd (LEqual (TBLD, Zero), LNotEqual (NPSS, Zero)))
                {
                    If (LOr (LEqual (And (TYPE, 0x1B), 0x1B), LEqual (DCOR, 
                        Zero)))
                    {
                        Store (One, TBLD)
                        Load (SSDT, HNDL)
                    }
                }
            }
        }
        Processor (P004, 0x04, 0x00000810, 0x06)
        {
            Name (TYPE, 0x80000000)
            Method (_PDC, 1, NotSerialized)
            {
                CreateDWordField (Arg0, 0x08, DAT0)
                Store (DAT0, TYPE)
                If (LAnd (LEqual (TBLD, Zero), LNotEqual (NPSS, Zero)))
                {
                    If (LOr (LEqual (And (TYPE, 0x1B), 0x1B), LEqual (DCOR, 
                        Zero)))
                    {
                        Store (One, TBLD)
                        Load (SSDT, HNDL)
                    }
                }
            }
        }
        Processor (P005, 0x05, 0x00000810, 0x06)
        {
            Name (TYPE, 0x80000000)
            Method (_PDC, 1, NotSerialized)
            {
                CreateDWordField (Arg0, 0x08, DAT0)
                Store (DAT0, TYPE)
                If (LAnd (LEqual (TBLD, Zero), LNotEqual (NPSS, Zero)))
                {
                    If (LOr (LEqual (And (TYPE, 0x1B), 0x1B), LEqual (DCOR, 
                        Zero)))
                    {
                        Store (One, TBLD)
                        Load (SSDT, HNDL)
                    }
                }
            }
        }
        Processor (P006, 0x06, 0x00000810, 0x06)
        {
            Name (TYPE, 0x80000000)
            Method (_PDC, 1, NotSerialized)
            {
                CreateDWordField (Arg0, 0x08, DAT0)
                Store (DAT0, TYPE)
                If (LAnd (LEqual (TBLD, Zero), LNotEqual (NPSS, Zero)))
                {
                    If (LOr (LEqual (And (TYPE, 0x1B), 0x1B), LEqual (DCOR, 
                        Zero)))
                    {
                        Store (One, TBLD)
                        Load (SSDT, HNDL)
                    }
                }
            }
        }
        Processor (P007, 0x07, 0x00000810, 0x06)
        {
            Name (TYPE, 0x80000000)
            Method (_PDC, 1, NotSerialized)
            {
                CreateDWordField (Arg0, 0x08, DAT0)
                Store (DAT0, TYPE)
                If (LAnd (LEqual (TBLD, Zero), LNotEqual (NPSS, Zero)))
                {
                    If (LOr (LEqual (And (TYPE, 0x1B), 0x1B), LEqual (DCOR, 
                        Zero)))
                    {
                        Store (One, TBLD)
                        Load (SSDT, HNDL)
                    }
                }
            }
        }
        Processor (P008, 0x08, 0x00000810, 0x06)
        {
            Name (TYPE, 0x80000000)
            Method (_PDC, 1, NotSerialized)
            {
                CreateDWordField (Arg0, 0x08, DAT0)
                Store (DAT0, TYPE)
                If (LAnd (LEqual (TBLD, Zero), LNotEqual (NPSS, Zero)))
                {
                    If (LOr (LEqual (And (TYPE, 0x1B), 0x1B), LEqual (DCOR, 
                        Zero)))
                    {
                        Store (One, TBLD)
                        Load (SSDT, HNDL)
                    }
                }
            }
        }
    }
    Scope (_SB.PCI0)
    {
        Method (_INI, 0, NotSerialized)
        {
            If (LLessEqual (RVID, 0x13)) {}
        }
    }
    Device (HPET)
    {
        Name (_HID, EisaId ("PNP0103"))
        Name (CRS, ResourceTemplate ()
        {
            Memory32Fixed (ReadOnly,
                0xFED00000,         // Address Base
                0x00000400,         // Address Length
                _Y26)
        })
        Method (_STA, 0, NotSerialized)
        {
            Return (0x0F)
        }
        Method (_CRS, 0, NotSerialized)
        {
            CreateDWordField (CRS, \HPET._Y26._BAS, HPT)
            Store (0xFED00000, HPT)
            Return (CRS)
        }
    }
    Scope (_SB)
    {
        Scope (PCI0)
        {
        }
    }
    Name (WOTB, Zero)
    Name (WSSB, Zero)
    Name (WAXB, Zero)
    Method (_PTS, 1, NotSerialized)
    {
        If (LEqual (Arg0, 0x05)) {}
         Else
         {
         Store (Arg0, DBG8)
        If (LAnd (LEqual (Arg0, 0x04), LEqual (OSFL (), 0x02)))
        {
            Sleep (0x0BB8)
        }
        PTS (Arg0)
        Store (Zero, Index (WAKP, Zero))
        Store (Zero, Index (WAKP, One))
        Store (ASSB, WSSB)
        Store (AOTB, WOTB)
        Store (AAXB, WAXB)
        Store (Arg0, ASSB)
        Store (OSFL (), AOTB)
        Store (Zero, AAXB)
         }
    }
    Method (_WAK, 1, NotSerialized)
    {
PINI ()
         ShiftLeft (Arg0, 0x04, DBG8)
        WAK (Arg0)
        If (IOWK) {}
        Else
        {
            Notify (\_SB.PWRB, 0x02)
        }
        If (ASSB)
        {
            Store (WSSB, ASSB)
            Store (WOTB, AOTB)
            Store (WAXB, AAXB)
        }
        If (DerefOf (Index (WAKP, Zero)))
        {
            Store (Zero, Index (WAKP, One))
        }
        Else
        {
            Store (Arg0, Index (WAKP, One))
        }
        Return (WAKP)
    }
    OperationRegion (IORK, SystemIO, 0xB3, One)
    Field (IORK, ByteAcc, NoLock, Preserve)
    {
        IOWK,   8
    }
    Device (OMSC)
    {
        Name (_HID, EisaId ("PNP0C02"))
        Name (_UID, 0x0E11)
    }
    Device (_SB.RMEM)
    {
        Name (_HID, EisaId ("PNP0C01"))
        Name (_UID, One)
    }
    Scope (\)
    {
        Device (AMW0)
        {
            Name (_HID, EisaId ("PNP0C14"))
            Name (_UID, "ASUSWMI")
            Name (_WDG, Buffer (0x50)
            {
                /* 0000 */   0xD0, 0x5E, 0x84, 0x97, 0x6D, 0x4E, 0xDE, 0x11,
                /* 0008 */   0x8A, 0x39, 0x08, 0x00, 0x20, 0x0C, 0x9A, 0x66,
                /* 0010 */   0x42, 0x43, 0x01, 0x02, 0xA0, 0x47, 0x67, 0x46,
                /* 0018 */   0xEC, 0x70, 0xDE, 0x11, 0x8A, 0x39, 0x08, 0x00,
                /* 0020 */   0x20, 0x0C, 0x9A, 0x66, 0x42, 0x44, 0x01, 0x02,
                /* 0028 */   0x72, 0x0F, 0xBC, 0xAB, 0xA1, 0x8E, 0xD1, 0x11,
                /* 0030 */   0x00, 0xA0, 0xC9, 0x06, 0x29, 0x10, 0x00, 0x00,
                /* 0038 */   0xD2, 0x00, 0x01, 0x08, 0x21, 0x12, 0x90, 0x05,
                /* 0040 */   0x66, 0xD5, 0xD1, 0x11, 0xB2, 0xF0, 0x00, 0xA0,
                /* 0048 */   0xC9, 0x06, 0x29, 0x10, 0x4D, 0x4F, 0x01, 0x00
            })
            Name (CCAC, Zero)
            Name (ECD2, Zero)
            Name (EID2, Zero)
            Method (WED2, 1, NotSerialized)
            {
                Store (Arg0, ECD2)
            }
            Method (WMBC, 3, NotSerialized)
            {
                Store (One, Local0)
                Name (T_0, Zero)
                Store (Arg1, T_0)
                If (LEqual (T_0, 0x43455053))
                {
                    Return (SPEC (Arg2))
                }
                Else
                {
                    If (LEqual (T_0, 0x50564544))
                    {
                        Return (DEVP (Arg2))
                    }
                    Else
                    {
                        If (LEqual (T_0, 0x50534453))
                        {
                            Return (SDSP (Arg2))
                        }
                        Else
                        {
                            If (LEqual (T_0, 0x50534447))
                            {
                                Return (GDSP (Arg2))
                            }
                            Else
                            {
                                If (LEqual (T_0, 0x53564544))
                                {
                                    Return (DEVS (Arg2))
                                }
                                Else
                                {
                                    If (LEqual (T_0, 0x53544344))
                                    {
                                        Return (DSTS (Arg2))
                                    }
                                    Else
                                    {
                                        If (LEqual (T_0, 0x44495047))
                                        {
                                            Return (GPID ())
                                        }
                                        Else
                                        {
                                            If (LEqual (T_0, 0x5446424B))
                                            {
                                                Return (KBFT (Arg2))
                                            }
                                            Else
                                            {
                                                If (LEqual (T_0, 0x59454B48))
                                                {
                                                    Return (HKEY ())
                                                }
                                                Else
                                                {
                                                    Return (Zero)
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                Return (Local0)
            }
            Method (RSMB, 1, Serialized)
            {
                Return (Zero)
            }
            Method (WSMB, 1, Serialized)
            {
                Return (Zero)
            }
            Method (RSMW, 1, Serialized)
            {
                Return (Zero)
            }
            Method (WSMW, 1, Serialized)
            {
                Return (Zero)
            }
            Method (RSMK, 1, Serialized)
            {
                Return (Zero)
            }
            Method (WSMK, 1, Serialized)
            {
                Return (Zero)
            }
            Method (WMBD, 3, NotSerialized)
            {
                Store (One, Local0)
                Name (T_0, Zero)
                Store (Arg1, T_0)
                If (LEqual (T_0, 0x424D5352))
                {
                    Return (RSMB (Arg2))
                }
                Else
                {
                    If (LEqual (T_0, 0x424D5357))
                    {
                        Return (WSMB (Arg2))
                    }
                    Else
                    {
                        If (LEqual (T_0, 0x574D5352))
                        {
                            Return (RSMW (Arg2))
                        }
                        Else
                        {
                            If (LEqual (T_0, 0x574D5357))
                            {
                                Return (WSMW (Arg2))
                            }
                            Else
                            {
                                If (LEqual (T_0, 0x4B4D5352))
                                {
                                    Return (RSMK (Arg2))
                                }
                                Else
                                {
                                    If (LEqual (T_0, 0x4B4D5357))
                                    {
                                        Return (WSMK (Arg2))
                                    }
                                    Else
                                    {
                                        Return (Zero)
                                    }
                                }
                            }
                        }
                    }
                }
                Return (Local0)
            }
            Method (_WED, 1, NotSerialized)
            {
                If (LEqual (Arg0, 0xD2))
                {
                    Return (EID2)
                }
                Return (Zero)
            }
            Method (AMWR, 1, Serialized)
            {
                Store (Zero, Local1)
                If (ECD2)
                {
                    Store (Arg0, EID2)
                    Notify (AMW0, 0xD2)
                    Store (One, Local1)
                }
                Else
                {
                }
                Return (Local1)
            }
            Method (AMWN, 1, Serialized)
            {
                Store (AMWR (Arg0), Local0)
                Return (Local0)
            }
            Name (WQMO, Buffer (0x09A6)
            {
                /* 0000 */   0x46, 0x4F, 0x4D, 0x42, 0x01, 0x00, 0x00, 0x00,
                /* 0008 */   0x96, 0x09, 0x00, 0x00, 0x42, 0x38, 0x00, 0x00,
                /* 0010 */   0x44, 0x53, 0x00, 0x01, 0x1A, 0x7D, 0xDA, 0x54,
                /* 0018 */   0xA8, 0xD1, 0x9A, 0x00, 0x01, 0x06, 0x18, 0x42,
                /* 0020 */   0x10, 0x07, 0x10, 0x4A, 0x29, 0x86, 0x42, 0x04,
                /* 0028 */   0x0A, 0x0D, 0xA1, 0x38, 0x0A, 0x60, 0x30, 0x12,
                /* 0030 */   0x20, 0x24, 0x07, 0x42, 0x2E, 0x98, 0x98, 0x00,
                /* 0038 */   0x11, 0x10, 0xF2, 0x2A, 0xC0, 0xA6, 0x00, 0x93,
                /* 0040 */   0x20, 0xEA, 0xDF, 0x1F, 0xA2, 0x24, 0x38, 0x94,
                /* 0048 */   0x10, 0x08, 0x49, 0x14, 0x60, 0x5E, 0x80, 0x6E,
                /* 0050 */   0x01, 0x86, 0x05, 0xD8, 0x16, 0x60, 0x5A, 0x80,
                /* 0058 */   0x63, 0x48, 0x2A, 0x0D, 0x9C, 0x12, 0x58, 0x0A,
                /* 0060 */   0x84, 0x84, 0x0A, 0x50, 0x2E, 0xC0, 0xB7, 0x00,
                /* 0068 */   0xED, 0x88, 0x92, 0x2C, 0xC0, 0x32, 0x8C, 0x08,
                /* 0070 */   0x3C, 0x8A, 0xC8, 0x46, 0xE3, 0x04, 0x65, 0x43,
                /* 0078 */   0xA3, 0x64, 0x40, 0xC8, 0xB3, 0x00, 0xEB, 0xC0,
                /* 0080 */   0x84, 0xC0, 0xEE, 0x05, 0x98, 0x13, 0xE0, 0x4D,
                /* 0088 */   0x80, 0xB8, 0x61, 0x68, 0x85, 0x07, 0x10, 0xAA,
                /* 0090 */   0x30, 0x01, 0xB6, 0x60, 0x84, 0x52, 0x1B, 0x8C,
                /* 0098 */   0x50, 0x1A, 0x43, 0xD0, 0x30, 0x8C, 0x12, 0xF1,
                /* 00A0 */   0x90, 0x3A, 0x83, 0x15, 0x4A, 0xC4, 0x30, 0x21,
                /* 00A8 */   0x22, 0x54, 0x86, 0x41, 0x86, 0x15, 0x2A, 0x5A,
                /* 00B0 */   0xDC, 0x08, 0xED, 0x0F, 0x82, 0x44, 0x5B, 0xB1,
                /* 00B8 */   0x86, 0xEA, 0x48, 0xA3, 0x41, 0x0D, 0x2F, 0xC1,
                /* 00C0 */   0xE1, 0x7A, 0xA8, 0xE7, 0xD8, 0xB9, 0x00, 0xE9,
                /* 00C8 */   0xC0, 0x02, 0x09, 0x7E, 0x16, 0x75, 0x8E, 0x93,
                /* 00D0 */   0x80, 0x24, 0x30, 0xD6, 0xF1, 0xB3, 0x81, 0xE3,
                /* 00D8 */   0x5D, 0x03, 0x6A, 0xC6, 0xC7, 0xCB, 0x04, 0xC1,
                /* 00E0 */   0xA1, 0x86, 0xE8, 0x81, 0x86, 0x3B, 0x81, 0x43,
                /* 00E8 */   0x64, 0x80, 0x9E, 0xD3, 0xD1, 0x60, 0x0E, 0x00,
                /* 00F0 */   0x76, 0x38, 0x19, 0xDD, 0x03, 0x4A, 0x15, 0x60,
                /* 00F8 */   0x76, 0xCC, 0xB2, 0x08, 0xA4, 0xF1, 0x18, 0xFA,
                /* 0100 */   0x74, 0xCF, 0xE7, 0x84, 0x13, 0x58, 0xFE, 0x20,
                /* 0108 */   0x50, 0x23, 0x33, 0xB4, 0x0D, 0x4E, 0x4B, 0x98,
                /* 0110 */   0x21, 0x0F, 0xFF, 0xB0, 0x98, 0x58, 0x08, 0x7D,
                /* 0118 */   0x10, 0x3C, 0x1E, 0x78, 0xFF, 0xFF, 0xF1, 0x80,
                /* 0120 */   0x47, 0xF1, 0x99, 0x40, 0x08, 0xAF, 0x04, 0xB1,
                /* 0128 */   0x3D, 0xA0, 0xE7, 0x04, 0x03, 0x63, 0x07, 0x64,
                /* 0130 */   0xBF, 0x02, 0x10, 0x82, 0x97, 0x39, 0x22, 0x39,
                /* 0138 */   0x45, 0xD0, 0x98, 0x8C, 0xD1, 0x2A, 0x84, 0x86,
                /* 0140 */   0x10, 0xDA, 0x10, 0x67, 0x17, 0xFF, 0xE0, 0x0D,
                /* 0148 */   0x73, 0xEE, 0x26, 0x28, 0x72, 0x04, 0xA8, 0xCF,
                /* 0150 */   0x84, 0x47, 0xC0, 0x8F, 0x01, 0xD1, 0x43, 0x9F,
                /* 0158 */   0x4D, 0xF4, 0xE3, 0x89, 0x72, 0x12, 0x07, 0xE4,
                /* 0160 */   0x33, 0x83, 0x11, 0x82, 0x97, 0x7B, 0x48, 0x20,
                /* 0168 */   0x9A, 0xE7, 0xA0, 0x13, 0xC3, 0x39, 0x1D, 0x02,
                /* 0170 */   0x53, 0xA3, 0x05, 0xA2, 0x09, 0x10, 0x45, 0x59,
                /* 0178 */   0xAA, 0x6C, 0x2C, 0xD5, 0x83, 0xA0, 0x82, 0x80,
                /* 0180 */   0x34, 0x77, 0x43, 0x9C, 0xB4, 0x91, 0x03, 0xC7,
                /* 0188 */   0xA8, 0x7E, 0xD8, 0x54, 0x04, 0x9C, 0x0E, 0x1B,
                /* 0190 */   0x1E, 0xB7, 0xE3, 0x93, 0x28, 0xFA, 0x80, 0x28,
                /* 0198 */   0x9C, 0xC3, 0x9E, 0x39, 0x28, 0x88, 0x01, 0x9D,
                /* 01A0 */   0x04, 0x42, 0x4E, 0x8E, 0x02, 0xA8, 0xBD, 0x68,
                /* 01A8 */   0x58, 0x1A, 0xD7, 0xA9, 0xBD, 0x09, 0x78, 0x5A,
                /* 01B0 */   0x8F, 0x05, 0x87, 0x71, 0x5C, 0x67, 0x6D, 0xD1,
                /* 01B8 */   0x37, 0x06, 0x3A, 0x1F, 0xDF, 0x05, 0xB8, 0x06,
                /* 01C0 */   0x08, 0xCD, 0xC8, 0xF0, 0x56, 0x03, 0x48, 0xC1,
                /* 01C8 */   0xF8, 0x49, 0xE0, 0x11, 0xC0, 0x04, 0xD6, 0x75,
                /* 01D0 */   0x20, 0x80, 0x7E, 0xD9, 0xF0, 0xF0, 0x7D, 0xC2,
                /* 01D8 */   0x78, 0xBC, 0x48, 0x50, 0xDF, 0x7D, 0x00, 0x14,
                /* 01E0 */   0x40, 0x3E, 0x00, 0x58, 0xE9, 0x1D, 0x80, 0x8E,
                /* 01E8 */   0x21, 0x44, 0x98, 0x68, 0x46, 0xE7, 0x12, 0x56,
                /* 01F0 */   0xAA, 0xFF, 0xFF, 0x68, 0xF9, 0x41, 0xC5, 0xA3,
                /* 01F8 */   0x35, 0x88, 0x47, 0xEB, 0x40, 0xA3, 0x45, 0x1F,
                /* 0200 */   0x33, 0xAC, 0x70, 0x54, 0xF2, 0x39, 0x01, 0x0D,
                /* 0208 */   0x17, 0x06, 0x41, 0xE1, 0x07, 0x0E, 0x68, 0x80,
                /* 0210 */   0xA7, 0xF7, 0x66, 0xE0, 0x99, 0x18, 0xCE, 0xF3,
                /* 0218 */   0xE5, 0x70, 0x9E, 0x2F, 0x1F, 0x8E, 0x0F, 0x14,
                /* 0220 */   0xF0, 0x07, 0x8C, 0x25, 0x28, 0x70, 0xC2, 0x20,
                /* 0228 */   0x87, 0xC7, 0x08, 0x1E, 0x2C, 0x95, 0x35, 0x2E,
                /* 0230 */   0xD4, 0xFD, 0xC0, 0x27, 0x1A, 0x86, 0x7D, 0xA8,
                /* 0238 */   0x47, 0xF3, 0x96, 0x70, 0x86, 0x6F, 0x13, 0x07,
                /* 0240 */   0xF5, 0xEE, 0x61, 0xA7, 0x42, 0x2D, 0x3A, 0x84,
                /* 0248 */   0xF5, 0x48, 0x39, 0xAC, 0xD1, 0xC2, 0x1E, 0xF0,
                /* 0250 */   0x73, 0x87, 0xEF, 0x19, 0xFC, 0x4A, 0xE3, 0x63,
                /* 0258 */   0x08, 0x5D, 0x85, 0x4E, 0x15, 0x5C, 0x14, 0x84,
                /* 0260 */   0xE2, 0xAD, 0x45, 0xC3, 0x3F, 0x0B, 0x8F, 0xEB,
                /* 0268 */   0x15, 0xC3, 0x57, 0x80, 0x87, 0x13, 0x9F, 0x01,
                /* 0270 */   0xE2, 0x07, 0x3A, 0x82, 0x17, 0x11, 0x9F, 0x7D,
                /* 0278 */   0x7C, 0x79, 0xF1, 0x21, 0x83, 0x9D, 0x2C, 0x78,
                /* 0280 */   0x08, 0x0A, 0xC5, 0x38, 0x1C, 0xA0, 0x84, 0xC3,
                /* 0288 */   0x08, 0xCE, 0x20, 0x1E, 0x9E, 0x83, 0x1C, 0x0E,
                /* 0290 */   0xD0, 0xE7, 0x20, 0x0F, 0x84, 0x0D, 0xC2, 0x20,
                /* 0298 */   0xE7, 0xF1, 0xF2, 0xC3, 0x2E, 0x16, 0xF8, 0xFF,
                /* 02A0 */   0xFF, 0xC5, 0x02, 0x78, 0xA5, 0x19, 0x14, 0x5A,
                /* 02A8 */   0xCF, 0xA0, 0x20, 0x60, 0x3C, 0x3F, 0x78, 0xBC,
                /* 02B0 */   0x9E, 0xAD, 0xA7, 0x05, 0xDE, 0x11, 0xFB, 0xFC,
                /* 02B8 */   0x01, 0x9C, 0xC3, 0x1F, 0x5E, 0x50, 0x71, 0x87,
                /* 02C0 */   0x44, 0x41, 0x7C, 0x36, 0x70, 0x94, 0xF1, 0xA2,
                /* 02C8 */   0x67, 0xE2, 0xC3, 0x90, 0x8F, 0x0B, 0x4F, 0x37,
                /* 02D0 */   0x98, 0xC3, 0x07, 0xB8, 0x47, 0xE2, 0xC3, 0x07,
                /* 02D8 */   0xF0, 0xF8, 0xFF, 0x1F, 0x3E, 0x80, 0x9F, 0x44,
                /* 02E0 */   0x8B, 0x5A, 0x85, 0x1E, 0x3E, 0xC0, 0x15, 0xE4,
                /* 02E8 */   0x84, 0x84, 0x96, 0x73, 0xF8, 0x40, 0x4E, 0x24,
                /* 02F0 */   0x4C, 0x74, 0x9F, 0x91, 0x5E, 0x3C, 0x2C, 0xE1,
                /* 02F8 */   0xE0, 0x81, 0x0A, 0x4F, 0xA2, 0xF8, 0xA7, 0x02,
                /* 0300 */   0x54, 0xE0, 0x53, 0x01, 0x05, 0x31, 0xA0, 0x0F,
                /* 0308 */   0x15, 0x70, 0x66, 0xF0, 0xEC, 0x85, 0x99, 0x07,
                /* 0310 */   0x8C, 0x33, 0x12, 0x60, 0xEB, 0x50, 0x01, 0xDE,
                /* 0318 */   0xFF, 0xFF, 0xA1, 0x02, 0x38, 0x1C, 0x90, 0x00,
                /* 0320 */   0x59, 0x12, 0x2F, 0x48, 0x0F, 0x15, 0xE0, 0x3A,
                /* 0328 */   0x70, 0xFA, 0x50, 0xC1, 0x0F, 0x9A, 0x16, 0x05,
                /* 0330 */   0xA4, 0x23, 0x9E, 0x0F, 0x15, 0x30, 0x2E, 0x42,
                /* 0338 */   0x86, 0x7F, 0xAD, 0x3B, 0x96, 0xE7, 0x30, 0x72,
                /* 0340 */   0xAE, 0x40, 0xC7, 0x3E, 0x18, 0xA0, 0x82, 0x8E,
                /* 0348 */   0x9E, 0x82, 0x18, 0xD0, 0x29, 0x0E, 0x06, 0x68,
                /* 0350 */   0x1D, 0xE7, 0x0A, 0xD4, 0x31, 0x0E, 0xF8, 0xFD,
                /* 0358 */   0xFF, 0xCF, 0x14, 0xC0, 0x49, 0xC4, 0xD1, 0x0A,
                /* 0360 */   0x35, 0x5C, 0x8F, 0xD5, 0x20, 0x1E, 0xAB, 0x8F,
                /* 0368 */   0xA1, 0x1E, 0x2B, 0xEE, 0x1B, 0xE0, 0x23, 0x00,
                /* 0370 */   0xFE, 0xE8, 0x84, 0x03, 0x7B, 0xAE, 0x00, 0x4C,
                /* 0378 */   0x7B, 0x3C, 0x57, 0x80, 0x4E, 0xDA, 0xD9, 0x07,
                /* 0380 */   0x1D, 0x70, 0xAD, 0x3A, 0x89, 0xE1, 0xCF, 0x71,
                /* 0388 */   0x8C, 0x60, 0xA8, 0xC3, 0x1B, 0x85, 0x70, 0x1C,
                /* 0390 */   0x0A, 0x85, 0x39, 0x19, 0xD0, 0xFF, 0xFF, 0x11,
                /* 0398 */   0x96, 0xC0, 0x51, 0x10, 0x0F, 0xCD, 0x61, 0xCE,
                /* 03A0 */   0x70, 0xA0, 0x39, 0x16, 0xC0, 0xBB, 0x55, 0xB0,
                /* 03A8 */   0x63, 0x01, 0x6C, 0x02, 0x1F, 0x0B, 0xC0, 0x17,
                /* 03B0 */   0x67, 0x58, 0xE8, 0xD1, 0xFA, 0xFE, 0x87, 0xBB,
                /* 03B8 */   0x3F, 0x44, 0x79, 0x29, 0xF6, 0x21, 0x07, 0xEE,
                /* 03C0 */   0xB8, 0xC0, 0x71, 0x7A, 0x00, 0x5C, 0x1D, 0xC4,
                /* 03C8 */   0xE4, 0xF4, 0xF4, 0x00, 0xAE, 0x24, 0xA7, 0x07,
                /* 03D0 */   0xD4, 0x80, 0xFD, 0xFF, 0xD7, 0x03, 0xA4, 0x73,
                /* 03D8 */   0x02, 0xF6, 0xA2, 0xCD, 0x20, 0x4E, 0xF4, 0x79,
                /* 03E0 */   0xC4, 0x0A, 0x8E, 0x38, 0xA8, 0xEC, 0x24, 0x4A,
                /* 03E8 */   0x7E, 0xC4, 0x41, 0x65, 0x1D, 0x3B, 0x05, 0x31,
                /* 03F0 */   0xA0, 0x4F, 0x94, 0x80, 0x8F, 0x3B, 0x0E, 0xB0,
                /* 03F8 */   0xD8, 0xA8, 0x27, 0xCB, 0x23, 0x4F, 0x96, 0x82,
                /* 0400 */   0x78, 0xB2, 0xBE, 0x54, 0x00, 0x87, 0x1B, 0x0E,
                /* 0408 */   0xB0, 0xFF, 0xFF, 0x5F, 0x2A, 0x80, 0x92, 0x43,
                /* 0410 */   0xA9, 0x97, 0x0A, 0x90, 0xC9, 0xBB, 0xE1, 0xA0,
                /* 0418 */   0x43, 0xAE, 0x55, 0xF7, 0x3A, 0x76, 0x6C, 0xF5,
                /* 0420 */   0xB8, 0x7D, 0x93, 0xC6, 0x04, 0xBB, 0xE1, 0xA0,
                /* 0428 */   0x22, 0x51, 0x28, 0xD0, 0xB9, 0x00, 0x15, 0x01,
                /* 0430 */   0x8E, 0x82, 0x78, 0x68, 0x3E, 0x17, 0x58, 0xC9,
                /* 0438 */   0xB9, 0x00, 0xED, 0xFD, 0x42, 0x41, 0x06, 0xE7,
                /* 0440 */   0x7B, 0x81, 0x61, 0x8A, 0x1F, 0x8A, 0xEE, 0x3D,
                /* 0448 */   0x3E, 0x17, 0x80, 0xFB, 0x8A, 0x03, 0x2E, 0x63,
                /* 0450 */   0x02, 0xB4, 0x41, 0x92, 0x7B, 0xB8, 0xC7, 0x85,
                /* 0458 */   0x1B, 0x87, 0x47, 0x75, 0x4C, 0x31, 0x9F, 0xE3,
                /* 0460 */   0x82, 0x3C, 0xC7, 0x79, 0x5E, 0xB8, 0xF3, 0x03,
                /* 0468 */   0x70, 0xFB, 0xFF, 0x0F, 0x0C, 0xD6, 0x85, 0x0B,
                /* 0470 */   0x88, 0x0B, 0x35, 0x29, 0xF1, 0xFC, 0x00, 0xAE,
                /* 0478 */   0x5B, 0xB7, 0xEF, 0x85, 0x38, 0x29, 0x77, 0x57,
                /* 0480 */   0x14, 0xC6, 0x2B, 0x49, 0x0C, 0xDF, 0x53, 0x8D,
                /* 0488 */   0x6D, 0x98, 0x03, 0x38, 0x15, 0xE3, 0x24, 0x18,
                /* 0490 */   0xFC, 0xEC, 0x40, 0xC7, 0xE5, 0xC8, 0x24, 0xBA,
                /* 0498 */   0xED, 0xFB, 0x08, 0xC1, 0x63, 0x8E, 0x9E, 0x82,
                /* 04A0 */   0x18, 0xD0, 0x19, 0x4E, 0x2A, 0x68, 0x15, 0x20,
                /* 04A8 */   0x9A, 0x02, 0xE6, 0xE6, 0x0A, 0xF8, 0xFB, 0xFF,
                /* 04B0 */   0xDF, 0x5C, 0x01, 0x56, 0xB8, 0x54, 0xA8, 0x51,
                /* 04B8 */   0xEA, 0x91, 0x02, 0x5C, 0x77, 0x40, 0xDF, 0xC2,
                /* 04C0 */   0x70, 0x92, 0x80, 0x74, 0x65, 0x3D, 0x8D, 0x07,
                /* 04C8 */   0x00, 0x5F, 0x29, 0x60, 0x5C, 0x3C, 0xD9, 0x11,
                /* 04D0 */   0x87, 0xDF, 0xAE, 0x7D, 0x2C, 0x00, 0xE6, 0xFF,
                /* 04D8 */   0xFF, 0x2B, 0x21, 0x58, 0x8F, 0x05, 0xC0, 0x5B,
                /* 04E0 */   0xA4, 0x4B, 0x8B, 0x66, 0x8F, 0x05, 0xE0, 0x12,
                /* 04E8 */   0xBF, 0x0A, 0x7A, 0x50, 0xB1, 0x5C, 0x18, 0x94,
                /* 04F0 */   0x84, 0xB1, 0x43, 0x19, 0xCD, 0xC1, 0x1C, 0x43,
                /* 04F8 */   0x70, 0x76, 0x86, 0x31, 0x1C, 0x1F, 0xA8, 0xA7,
                /* 0500 */   0xFE, 0x58, 0x7B, 0x1A, 0xAF, 0x68, 0xBE, 0xE2,
                /* 0508 */   0xF9, 0x3E, 0x4A, 0x87, 0x88, 0xBA, 0xEA, 0x79,
                /* 0510 */   0xAC, 0x6F, 0x05, 0xA7, 0xF6, 0xAC, 0xE7, 0x6B,
                /* 0518 */   0x8B, 0x61, 0x12, 0x78, 0x88, 0x0C, 0x8D, 0x13,
                /* 0520 */   0xBC, 0x23, 0x19, 0x9A, 0xCB, 0x80, 0xD0, 0x5D,
                /* 0528 */   0xE9, 0x35, 0xC0, 0x73, 0x33, 0x41, 0xF7, 0x43,
                /* 0530 */   0x97, 0x42, 0x04, 0x9D, 0x00, 0xDE, 0x09, 0x6A,
                /* 0538 */   0x14, 0xE0, 0xED, 0x2A, 0x20, 0x5B, 0x02, 0xC4,
                /* 0540 */   0x8D, 0x5E, 0x58, 0x6F, 0x45, 0x51, 0x42, 0x44,
                /* 0548 */   0x08, 0x1A, 0xC5, 0x78, 0x11, 0x42, 0x85, 0x88,
                /* 0550 */   0x12, 0xB5, 0x39, 0x10, 0x5D, 0x8E, 0xA2, 0x06,
                /* 0558 */   0x89, 0x16, 0xCC, 0x08, 0xCC, 0xFE, 0x20, 0x88,
                /* 0560 */   0xF4, 0x67, 0x80, 0x2E, 0x33, 0xBE, 0x0C, 0x7B,
                /* 0568 */   0x34, 0xFC, 0x2C, 0xC5, 0x87, 0x7A, 0x8E, 0x8F,
                /* 0570 */   0x8A, 0xEC, 0xFF, 0x0F, 0xF2, 0x5A, 0x68, 0x9D,
                /* 0578 */   0xE3, 0x24, 0x87, 0x1C, 0x83, 0xEB, 0x0C, 0x01,
                /* 0580 */   0xCD, 0x35, 0xA0, 0x8E, 0xFD, 0x1E, 0xAF, 0xBF,
                /* 0588 */   0x1A, 0x86, 0xE3, 0x43, 0xF4, 0xA1, 0xC2, 0x13,
                /* 0590 */   0x38, 0x44, 0x06, 0xE8, 0x43, 0x04, 0xFC, 0xF1,
                /* 0598 */   0x18, 0xFA, 0x29, 0xC2, 0x13, 0x7E, 0xA1, 0x25,
                /* 05A0 */   0x83, 0x40, 0x9D, 0x34, 0xF8, 0x48, 0x5F, 0xB8,
                /* 05A8 */   0xD9, 0xED, 0xC3, 0x04, 0x16, 0x7B, 0x76, 0xA0,
                /* 05B0 */   0xE3, 0x01, 0xBF, 0xE2, 0x33, 0x81, 0xAE, 0x71,
                /* 05B8 */   0xC6, 0xF6, 0xC9, 0xC8, 0x11, 0x0E, 0x22, 0x50,
                /* 05C0 */   0x40, 0x9F, 0x4D, 0xF8, 0xCD, 0x83, 0x1D, 0x2D,
                /* 05C8 */   0xB8, 0xA8, 0xA3, 0x05, 0xEA, 0xB4, 0xE0, 0x83,
                /* 05D0 */   0x02, 0x43, 0x7C, 0xF8, 0x34, 0xC4, 0x93, 0x05,
                /* 05D8 */   0x3B, 0xEA, 0x80, 0x53, 0xDE, 0x21, 0x04, 0x14,
                /* 05E0 */   0x20, 0x3E, 0x59, 0xB0, 0x79, 0x61, 0x08, 0x2C,
                /* 05E8 */   0x12, 0x1E, 0x75, 0xE8, 0x30, 0x3C, 0x3F, 0x25,
                /* 05F0 */   0x3C, 0x8E, 0x30, 0xEC, 0x37, 0x12, 0x4F, 0xE1,
                /* 05F8 */   0x70, 0x7C, 0xA4, 0x30, 0x42, 0xF0, 0x72, 0x4F,
                /* 0600 */   0x16, 0xE4, 0x62, 0x73, 0x74, 0xFF, 0xFF, 0x27,
                /* 0608 */   0x18, 0xCC, 0x50, 0x3D, 0x04, 0x7E, 0x5E, 0xF0,
                /* 0610 */   0x10, 0xF8, 0x00, 0x5A, 0x9D, 0x1D, 0x39, 0x9F,
                /* 0618 */   0x9C, 0x13, 0x6E, 0xBC, 0x7C, 0x4C, 0xD8, 0x01,
                /* 0620 */   0xF0, 0xE0, 0x4B, 0xF2, 0x59, 0x84, 0xC6, 0x58,
                /* 0628 */   0xBE, 0x8F, 0x23, 0x80, 0x9C, 0x49, 0x3C, 0x81,
                /* 0630 */   0x44, 0x78, 0x19, 0x09, 0x12, 0xE2, 0x58, 0x5E,
                /* 0638 */   0x43, 0x0C, 0x12, 0xE3, 0xED, 0xC8, 0xC7, 0x11,
                /* 0640 */   0x0E, 0xF3, 0x4C, 0x62, 0xB8, 0x87, 0x83, 0x57,
                /* 0648 */   0x91, 0x17, 0x12, 0xC3, 0x3C, 0x8A, 0xF8, 0x7C,
                /* 0650 */   0x10, 0xC3, 0x98, 0xA1, 0xA2, 0x9D, 0x80, 0x8F,
                /* 0658 */   0x23, 0xEC, 0x58, 0xE9, 0xA1, 0xFA, 0x38, 0x02,
                /* 0660 */   0x58, 0xFA, 0xFF, 0x1F, 0x47, 0x80, 0xF9, 0x11,
                /* 0668 */   0x01, 0x77, 0xDA, 0x80, 0x7B, 0x9F, 0x08, 0xF1,
                /* 0670 */   0xA4, 0xF1, 0x92, 0xF0, 0xAC, 0x01, 0x5C, 0x84,
                /* 0678 */   0x6A, 0x39, 0xF7, 0xB0, 0x34, 0x8F, 0x01, 0x1D,
                /* 0680 */   0xCF, 0x38, 0x87, 0x35, 0x01, 0x69, 0x98, 0xFC,
                /* 0688 */   0xCA, 0xED, 0x73, 0xC1, 0xD9, 0x3D, 0x72, 0x1B,
                /* 0690 */   0x26, 0xC8, 0x13, 0xC1, 0x6B, 0x94, 0xC1, 0x05,
                /* 0698 */   0xA9, 0xF3, 0x23, 0x4F, 0x4F, 0x21, 0xDD, 0x27,
                /* 06A0 */   0x5A, 0x94, 0xD2, 0x63, 0x1A, 0x05, 0xF1, 0x19,
                /* 06A8 */   0xC1, 0x21, 0xCE, 0x31, 0xE8, 0xE1, 0x7B, 0x0E,
                /* 06B0 */   0x67, 0x74, 0x20, 0xEF, 0x01, 0xEC, 0xFE, 0x08,
                /* 06B8 */   0x3C, 0x4F, 0x3A, 0x78, 0x74, 0xDF, 0x14, 0xCE,
                /* 06C0 */   0xF3, 0x4C, 0xFF, 0xFF, 0x47, 0x04, 0xDE, 0x99,
                /* 06C8 */   0xFA, 0x82, 0x09, 0x9C, 0x43, 0xDC, 0x05, 0x50,
                /* 06D0 */   0xB2, 0xEF, 0x02, 0x14, 0xC4, 0x13, 0xF3, 0xD5,
                /* 06D8 */   0x0F, 0x0E, 0xFE, 0xAB, 0x1F, 0x30, 0xB9, 0x2C,
                /* 06E0 */   0xF8, 0x9A, 0x04, 0xBE, 0x53, 0x3F, 0xFE, 0xC2,
                /* 06E8 */   0xE0, 0xDB, 0xC0, 0xC3, 0x13, 0x1B, 0x14, 0xF8,
                /* 06F0 */   0xA1, 0x7C, 0x3D, 0x04, 0xFF, 0xFF, 0xFF, 0x7A,
                /* 06F8 */   0x08, 0x3C, 0x95, 0x3A, 0xB5, 0xA9, 0xF0, 0x7A,
                /* 0700 */   0x08, 0xAE, 0x28, 0xD7, 0x12, 0xD4, 0xAD, 0xC9,
                /* 0708 */   0x82, 0x80, 0x74, 0x3F, 0x7F, 0xBE, 0x31, 0xA6,
                /* 0710 */   0xCF, 0x25, 0xF0, 0xEE, 0xA0, 0x5A, 0x95, 0xEE,
                /* 0718 */   0x25, 0x3C, 0x38, 0x85, 0xA2, 0x1F, 0x1E, 0x50,
                /* 0720 */   0x61, 0x0F, 0x0F, 0x14, 0xC4, 0x17, 0x23, 0xDF,
                /* 0728 */   0x4B, 0x00, 0x0E, 0xFC, 0xFF, 0x47, 0xC4, 0x6F,
                /* 0730 */   0xDA, 0x70, 0x8E, 0x16, 0x98, 0x19, 0x81, 0xF5,
                /* 0738 */   0x44, 0xE0, 0x9B, 0x36, 0xE0, 0xE8, 0xE4, 0x02,
                /* 0740 */   0x5C, 0x4E, 0x25, 0x80, 0x2B, 0xAF, 0xA7, 0x12,
                /* 0748 */   0xFD, 0xFF, 0x4F, 0x25, 0xE0, 0xBA, 0x7B, 0x81,
                /* 0750 */   0xE9, 0x6A, 0x72, 0x26, 0xD1, 0x82, 0xFB, 0xEE,
                /* 0758 */   0x05, 0xF0, 0xF3, 0xFF, 0x7F, 0xF7, 0x02, 0x88,
                /* 0760 */   0xE9, 0xF5, 0xEE, 0x05, 0xBC, 0xCE, 0x25, 0x98,
                /* 0768 */   0xBB, 0x97, 0xFF, 0xFF, 0x77, 0x2F, 0x80, 0xFF,
                /* 0770 */   0xFF, 0xFF, 0xBB, 0x17, 0x40, 0x96, 0x53, 0x09,
                /* 0778 */   0xC8, 0xB2, 0x9D, 0x4A, 0xD0, 0x0A, 0xCF, 0xD1,
                /* 0780 */   0x50, 0x27, 0x70, 0x28, 0x4F, 0x18, 0xAF, 0xEA,
                /* 0788 */   0x09, 0xAC, 0xE7, 0xF2, 0x85, 0x52, 0x02, 0xA3,
                /* 0790 */   0xCB, 0x17, 0xB0, 0xFB, 0xFF, 0x5F, 0xBE, 0x00,
                /* 0798 */   0x3E, 0x04, 0xBA, 0x0B, 0xA0, 0x22, 0xDC, 0x05,
                /* 07A0 */   0x28, 0x88, 0x2F, 0x5F, 0x80, 0x97, 0x50, 0x10,
                /* 07A8 */   0x32, 0x72, 0x93, 0xA0, 0x97, 0x2F, 0x38, 0x17,
                /* 07B0 */   0x07, 0xDF, 0x8F, 0x3C, 0x28, 0x78, 0xFF, 0xFF,
                /* 07B8 */   0x41, 0xC1, 0x19, 0xCC, 0x79, 0x17, 0x7B, 0x52,
                /* 07C0 */   0xA4, 0xD7, 0x13, 0xB8, 0x77, 0x0E, 0x8F, 0x0D,
                /* 07C8 */   0x1C, 0xE2, 0xAE, 0x60, 0xC0, 0xDE, 0xE5, 0xED,
                /* 07D0 */   0x04, 0x5C, 0xDA, 0xD6, 0xAE, 0xDB, 0x09, 0x2E,
                /* 07D8 */   0xE1, 0x71, 0x1A, 0xF2, 0xF1, 0x04, 0x93, 0xE7,
                /* 07E0 */   0x76, 0x82, 0x4A, 0x02, 0xA3, 0x2C, 0x24, 0x3A,
                /* 07E8 */   0x42, 0x70, 0xF5, 0x37, 0x31, 0x0A, 0x62, 0x0B,
                /* 07F0 */   0xB7, 0x13, 0x40, 0xC7, 0xFF, 0xFF, 0x76, 0x02,
                /* 07F8 */   0xFC, 0xC7, 0x0C, 0x67, 0x44, 0xEF, 0x15, 0x86,
                /* 0800 */   0xF4, 0x19, 0x0C, 0x98, 0x06, 0x3A, 0x82, 0xA0,
                /* 0808 */   0x2F, 0x69, 0xD8, 0x04, 0x37, 0x10, 0x3A, 0x23,
                /* 0810 */   0x78, 0x17, 0x10, 0xB8, 0x13, 0x83, 0x75, 0x00,
                /* 0818 */   0x01, 0xDF, 0x59, 0x0D, 0x78, 0xFD, 0xFF, 0xCF,
                /* 0820 */   0x6A, 0xC0, 0xF4, 0x00, 0xE0, 0xB3, 0x1A, 0xA0,
                /* 0828 */   0xEA, 0xF6, 0x02, 0x32, 0x85, 0x36, 0x7D, 0x6A,
                /* 0830 */   0x34, 0x6A, 0xD5, 0xA0, 0x4C, 0x8D, 0x32, 0x0D,
                /* 0838 */   0x6A, 0xF5, 0xA9, 0xD4, 0x98, 0x31, 0xBB, 0x60,
                /* 0840 */   0x8A, 0x71, 0x7B, 0xA2, 0x22, 0x96, 0x23, 0x10,
                /* 0848 */   0xEB, 0xA6, 0x90, 0x91, 0xCB, 0x86, 0x41, 0x04,
                /* 0850 */   0x64, 0xD9, 0x8B, 0x16, 0x10, 0x01, 0x11, 0x90,
                /* 0858 */   0x85, 0xBC, 0x1B, 0x04, 0x64, 0x55, 0x20, 0x02,
                /* 0860 */   0x72, 0x2A, 0x20, 0x1A, 0x11, 0x88, 0xC6, 0xF1,
                /* 0868 */   0x00, 0xC4, 0xC2, 0x81, 0x08, 0xC8, 0xEA, 0x4C,
                /* 0870 */   0x00, 0x31, 0xA9, 0x20, 0xBA, 0x43, 0x90, 0xCF,
                /* 0878 */   0x85, 0x80, 0x2C, 0x12, 0x44, 0x40, 0xCE, 0xB8,
                /* 0880 */   0x3E, 0x01, 0x39, 0x30, 0x88, 0x80, 0x1C, 0xF2,
                /* 0888 */   0x1B, 0x22, 0x20, 0x47, 0x06, 0x11, 0x90, 0x05,
                /* 0890 */   0xEB, 0x00, 0xF2, 0xFF, 0x9F, 0xA0, 0x7C, 0x10,
                /* 0898 */   0x01, 0x39, 0x3E, 0x10, 0x15, 0xE3, 0xE3, 0xAE,
                /* 08A0 */   0x45, 0x1F, 0x03, 0x02, 0x72, 0x2E, 0x10, 0x01,
                /* 08A8 */   0x39, 0x07, 0x8D, 0x80, 0x9C, 0x8A, 0x42, 0x40,
                /* 08B0 */   0x56, 0xF5, 0x76, 0x10, 0x90, 0x35, 0x82, 0x08,
                /* 08B8 */   0xC8, 0x29, 0x81, 0x68, 0x66, 0x20, 0x2A, 0xD8,
                /* 08C0 */   0x0A, 0x10, 0x53, 0x0F, 0x22, 0x20, 0x2B, 0xD5,
                /* 08C8 */   0x02, 0xC4, 0x74, 0x83, 0x08, 0xC8, 0xA9, 0xBD,
                /* 08D0 */   0x00, 0x31, 0x0D, 0xEF, 0x00, 0x01, 0x59, 0xEB,
                /* 08D8 */   0xD3, 0x43, 0x20, 0x4E, 0x0A, 0x42, 0xB5, 0xBA,
                /* 08E0 */   0x01, 0x61, 0x39, 0xED, 0x80, 0x30, 0x95, 0x7A,
                /* 08E8 */   0x40, 0x58, 0x1E, 0x3F, 0x43, 0xA6, 0x20, 0x02,
                /* 08F0 */   0xB2, 0xA2, 0x97, 0x88, 0x80, 0x2C, 0x0F, 0x44,
                /* 08F8 */   0x40, 0x96, 0x62, 0x08, 0x88, 0x09, 0x03, 0x11,
                /* 0900 */   0x90, 0x23, 0x01, 0xD1, 0x80, 0x40, 0x54, 0x9E,
                /* 0908 */   0x23, 0x20, 0xA6, 0x15, 0x44, 0x40, 0x0E, 0x08,
                /* 0910 */   0x44, 0xD3, 0x02, 0x51, 0x8D, 0xBF, 0x25, 0x01,
                /* 0918 */   0x59, 0x30, 0x88, 0x80, 0x2C, 0xCE, 0xD2, 0x51,
                /* 0920 */   0x80, 0x82, 0x08, 0xC8, 0x31, 0x35, 0x0D, 0x95,
                /* 0928 */   0x82, 0x08, 0xC8, 0x42, 0x3D, 0x01, 0x31, 0xD5,
                /* 0930 */   0x20, 0x02, 0xB2, 0x42, 0x51, 0x40, 0x4C, 0x2F,
                /* 0938 */   0x88, 0x06, 0x49, 0x80, 0x68, 0x6E, 0x20, 0xAA,
                /* 0940 */   0x5A, 0x15, 0x10, 0x8B, 0x00, 0x22, 0x20, 0xE7,
                /* 0948 */   0x06, 0xA2, 0x22, 0x5C, 0x01, 0x31, 0xE9, 0x20,
                /* 0950 */   0x02, 0x72, 0x0E, 0x20, 0xAA, 0xF9, 0x49, 0x21,
                /* 0958 */   0x20, 0x27, 0x00, 0x11, 0x90, 0xF3, 0xDB, 0x3A,
                /* 0960 */   0x1A, 0xD0, 0x87, 0x8E, 0x80, 0x9C, 0x00, 0x44,
                /* 0968 */   0x40, 0x8E, 0x03, 0x44, 0xA5, 0xFB, 0x02, 0x62,
                /* 0970 */   0x41, 0x40, 0x04, 0x64, 0x41, 0xAF, 0x11, 0x0D,
                /* 0978 */   0x9C, 0x80, 0x08, 0xC8, 0xD1, 0x8C, 0x01, 0xB1,
                /* 0980 */   0x9C, 0x20, 0x02, 0xFA, 0xFF, 0x1F, 0xA8, 0xBE,
                /* 0988 */   0x22, 0x02, 0xB2, 0x52, 0x10, 0x0D, 0x9A, 0x00,
                /* 0990 */   0xD1, 0xB4, 0x40, 0x54, 0xF1, 0x9B, 0xE4, 0xD1,
                /* 0998 */   0x81, 0x81, 0xE8, 0x88, 0x40, 0xA4, 0x1D, 0x11,
                /* 09A0 */   0x28, 0x88, 0x80, 0xFC, 0xFF, 0x07
            })
            Method (SPEC, 1, Serialized)
            {
                Return (AMWV)
            }
            Method (DEVP, 1, Serialized)
            {
                CreateDWordField (Arg0, Zero, DVID)
                CreateDWordField (Arg0, 0x04, PARA)
                If (LEqual (PARA, One))
                {
                    Name (T_0, Zero)
                    Store (DVID, T_0)
                    If (LEqual (T_0, 0x00010011))
                    {
                        Or (\_SB.DSAF, One, \_SB.DSAF)
                    }
                    Else
                    {
                        If (LEqual (T_0, 0x00010013))
                        {
                            Or (\_SB.DSAF, 0x02, \_SB.DSAF)
                        }
                        Else
                        {
                            If (LEqual (T_0, 0x00010023))
                            {
                                Or (\_SB.DSAF, 0x04, \_SB.DSAF)
                            }
                            Else
                            {
                                If (LEqual (T_0, 0x00060013))
                                {
                                    Or (\_SB.DSAF, 0x08, \_SB.DSAF)
                                }
                                Else
                                {
                                    If (LEqual (T_0, 0x00060015))
                                    {
                                        Or (\_SB.DSAF, 0x10, \_SB.DSAF)
                                    }
                                    Else
                                    {
                                        If (LEqual (T_0, 0x00010015))
                                        {
                                            Or (\_SB.DSAF, 0x20, \_SB.DSAF)
                                        }
                                        Else
                                        {
                                            If (LEqual (T_0, 0x00090011))
                                            {
                                                Or (\_SB.DSAF, 0x40, \_SB.DSAF)
                                            }
                                            Else
                                            {
                                                If (LEqual (T_0, 0x00070011))
                                                {
                                                    Or (\_SB.DSAF, 0x80, \_SB.DSAF)
                                                }
                                                Else
                                                {
                                                    If (LEqual (T_0, 0x00080013))
                                                    {
                                                        Or (\_SB.DSAF, 0x0100, \_SB.DSAF)
                                                    }
                                                    Else
                                                    {
                                                        If (LEqual (T_0, 0x00010019))
                                                        {
                                                            Or (\_SB.DSAF, 0x0200, \_SB.DSAF)
                                                        }
                                                        Else
                                                        {
                                                            If (LEqual (T_0, 0x00010017))
                                                            {
                                                                Or (\_SB.DSAF, 0x0400, \_SB.DSAF)
                                                            }
                                                            Else
                                                            {
                                                                If (LEqual (T_0, 0x00050011))
                                                                {
                                                                    Or (\_SB.DSAF, 0x0800, \_SB.DSAF)
                                                                }
                                                                Else
                                                                {
                                                                    If (LEqual (T_0, 0x00050012))
                                                                    {
                                                                        Or (\_SB.DSAF, 0x1000, \_SB.DSAF)
                                                                    }
                                                                    Else
                                                                    {
                                                                        If (LEqual (T_0, 0x00060017))
                                                                        {
                                                                            Or (\_SB.DSAF, 0x2000, \_SB.DSAF)
                                                                        }
                                                                        Else
                                                                        {
                                                                            If (LEqual (T_0, 0x00080021))
                                                                            {
                                                                                Or (\_SB.DSAF, 0x4000, \_SB.DSAF)
                                                                            }
                                                                            Else
                                                                            {
                                                                                If (LEqual (T_0, 0x00100011))
                                                                                {
                                                                                    Or (\_SB.DSAF, 0x8000, \_SB.DSAF)
                                                                                }
                                                                                Else
                                                                                {
                                                                                    If (LEqual (T_0, 0x00050001))
                                                                                    {
                                                                                        Or (\_SB.DSAF, 0x00010000, \_SB.DSAF)
                                                                                    }
                                                                                    Else
                                                                                    {
                                                                                        If (LEqual (T_0, 0x00120000))
                                                                                        {
                                                                                            Or (\_SB.DSAF, 0x00020000, \_SB.DSAF)
                                                                                        }
                                                                                        Else
                                                                                        {
                                                                                            If (LEqual (T_0, 0x00120021))
                                                                                            {
                                                                                                Or (\_SB.DSAF, 0x00040000, \_SB.DSAF)
                                                                                            }
                                                                                            Else
                                                                                            {
                                                                                                If (LEqual (T_0, 0x00120011))
                                                                                                {
                                                                                                    Or (\_SB.DSAF, 0x00080000, \_SB.DSAF)
                                                                                                }
                                                                                                Else
                                                                                                {
                                                                                                    Return (Zero)
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                Else
                {
                    If (LEqual (PARA, Zero))
                    {
                        Name (T_1, Zero)
                        Store (DVID, T_1)
                        If (LEqual (T_1, 0x00010011))
                        {
                            And (\_SB.DSAF, 0xFFFFFFFFFFFFFFFE, \_SB.DSAF)
                        }
                        Else
                        {
                            If (LEqual (T_1, 0x00010013))
                            {
                                And (\_SB.DSAF, 0xFFFFFFFFFFFFFFFD, \_SB.DSAF)
                            }
                            Else
                            {
                                If (LEqual (T_1, 0x00010023))
                                {
                                    And (\_SB.DSAF, 0xFFFFFFFFFFFFFFFB, \_SB.DSAF)
                                }
                                Else
                                {
                                    If (LEqual (T_1, 0x00060013))
                                    {
                                        And (\_SB.DSAF, 0xFFFFFFFFFFFFFFF7, \_SB.DSAF)
                                    }
                                    Else
                                    {
                                        If (LEqual (T_1, 0x00060015))
                                        {
                                            And (\_SB.DSAF, 0xFFFFFFFFFFFFFFEF, \_SB.DSAF)
                                        }
                                        Else
                                        {
                                            If (LEqual (T_1, 0x00010015))
                                            {
                                                And (\_SB.DSAF, 0xFFFFFFFFFFFFFFDF, \_SB.DSAF)
                                            }
                                            Else
                                            {
                                                If (LEqual (T_1, 0x00090011))
                                                {
                                                    And (\_SB.DSAF, 0xFFFFFFFFFFFFFFBF, \_SB.DSAF)
                                                }
                                                Else
                                                {
                                                    If (LEqual (T_1, 0x00070011))
                                                    {
                                                        And (\_SB.DSAF, 0xFFFFFFFFFFFFFF7F, \_SB.DSAF)
                                                    }
                                                    Else
                                                    {
                                                        If (LEqual (T_1, 0x00080013))
                                                        {
                                                            And (\_SB.DSAF, 0xFFFFFFFFFFFFFEFF, \_SB.DSAF)
                                                        }
                                                        Else
                                                        {
                                                            If (LEqual (T_1, 0x00010019))
                                                            {
                                                                And (\_SB.DSAF, 0xFFFFFFFFFFFFFDFF, \_SB.DSAF)
                                                            }
                                                            Else
                                                            {
                                                                If (LEqual (T_1, 0x00010017))
                                                                {
                                                                    And (\_SB.DSAF, 0xFFFFFFFFFFFFFBFF, \_SB.DSAF)
                                                                }
                                                                Else
                                                                {
                                                                    If (LEqual (T_1, 0x00050011))
                                                                    {
                                                                        And (\_SB.DSAF, 0xFFFFFFFFFFFFF7FF, \_SB.DSAF)
                                                                    }
                                                                    Else
                                                                    {
                                                                        If (LEqual (T_1, 0x00050012))
                                                                        {
                                                                            And (\_SB.DSAF, 0xFFFFFFFFFFFFEFFF, \_SB.DSAF)
                                                                        }
                                                                        Else
                                                                        {
                                                                            If (LEqual (T_1, 0x00060017))
                                                                            {
                                                                                And (\_SB.DSAF, 0xFFFFFFFFFFFFDFFF, \_SB.DSAF)
                                                                            }
                                                                            Else
                                                                            {
                                                                                If (LEqual (T_1, 0x00080021))
                                                                                {
                                                                                    And (\_SB.DSAF, 0xFFFFFFFFFFFFBFFF, \_SB.DSAF)
                                                                                }
                                                                                Else
                                                                                {
                                                                                    If (LEqual (T_1, 0x00100011))
                                                                                    {
                                                                                        And (\_SB.DSAF, 0xFFFFFFFFFFFF7FFF, \_SB.DSAF)
                                                                                    }
                                                                                    Else
                                                                                    {
                                                                                        If (LEqual (T_1, 0x00050001))
                                                                                        {
                                                                                            And (\_SB.DSAF, 0xFFFFFFFFFFFEFFFF, \_SB.DSAF)
                                                                                        }
                                                                                        Else
                                                                                        {
                                                                                            If (LEqual (T_1, 0x00120000))
                                                                                            {
                                                                                                And (\_SB.DSAF, 0xFFFFFFFFFFFDFFFF, \_SB.DSAF)
                                                                                            }
                                                                                            Else
                                                                                            {
                                                                                                If (LEqual (T_1, 0x00120021))
                                                                                                {
                                                                                                    And (\_SB.DSAF, 0xFFFFFFFFFFFBFFFF, \_SB.DSAF)
                                                                                                }
                                                                                                Else
                                                                                                {
                                                                                                    If (LEqual (T_1, 0x00120011))
                                                                                                    {
                                                                                                        And (\_SB.DSAF, 0xFFFFFFFFFFF7FFFF, \_SB.DSAF)
                                                                                                    }
                                                                                                    Else
                                                                                                    {
                                                                                                        Return (Zero)
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                Return (One)
            }
            Method (SDSP, 1, Serialized)
            {
                CreateDWordField (Arg0, Zero, ACTN)
                Return (Zero)
            }
            Method (GDSP, 1, Serialized)
            {
                CreateDWordField (Arg0, Zero, ACTN)
                Return (Zero)
            }
            Method (DEVS, 1, Serialized)
            {
                CreateDWordField (Arg0, Zero, DVID)
                CreateDWordField (Arg0, 0x04, CPAR)
                Name (T_0, Zero)
                Store (DVID, T_0)
                If (LEqual (T_0, Zero))
                {
                    Return (Zero)
                }
                Else
                {
                    Return (Zero)
                }
            }
            Method (DSTS, 1, Serialized)
            {
                CreateDWordField (Arg0, Zero, DVID)
                Name (T_0, Zero)
                Store (DVID, T_0)
                If (LEqual (T_0, 0xA0000000))
                {
                    Store (One, Local0)
                }
                Else
                {
                    If (LEqual (T_0, Zero))
                    {
                        Return (Zero)
                    }
                    Else
                    {
                        Store (Zero, Local0)
                    }
                }
                And (Local0, 0x0007FFFF, Local0)
                Return (Local0)
            }
            Method (GPID, 0, Serialized)
            {
                Return (Zero)
            }
            Method (KBFT, 1, Serialized)
            {
                Return (Zero)
            }
            Method (HKEY, 0, Serialized)
            {
                Return (Zero)
            }
            Method (CFVS, 1, Serialized)
            {
            }
            Method (CFVG, 0, Serialized)
            {
            }
        }
    }
    Scope (_SB)
    {
        Name (RAMB, 0xDDAD7018)
        OperationRegion (\RAMW, SystemMemory, RAMB, 0x00010000)
        Field (RAMW, ByteAcc, NoLock, Preserve)
        {
            DSAF,   256, 
            PAR0,   32, 
            PAR1,   32, 
            PAR2,   32, 
            PINX,   32, 
            PADD,   2048
        }
        Mutex (MPAR, 0x00)
        Name (ARBF, Buffer (0x10) {})
        CreateDWordField (ARBF, Zero, REAX)
        CreateDWordField (ARBF, 0x04, REBX)
        CreateDWordField (ARBF, 0x08, RECX)
        CreateDWordField (ARBF, 0x0C, REDX)
        OperationRegion (IOB2, SystemIO, SMIP, 0x02)
        Field (IOB2, ByteAcc, NoLock, Preserve)
        {
            SMIC,   8, 
            SMIS,   8
        }
        Method (ISMI, 1, Serialized)
        {
            Store (Arg0, SMIC)
        }
        Method (GMSR, 1, Serialized)
        {
            If (LEqual (Acquire (MPAR, 0xFFFF), Zero))
            {
                Store (0x80000000, PINX)
                Store (Arg0, PAR0)
                ISMI (0x90)
                Store (Arg0, RECX)
                Store (PAR1, REAX)
                Store (PAR2, REDX)
                Release (MPAR)
                Return (ARBF)
            }
            Return (Ones)
        }
        Method (SMSR, 1, Serialized)
        {
            If (LEqual (Acquire (MPAR, 0xFFFF), Zero))
            {
                CreateDWordField (Arg0, Zero, AEAX)
                CreateDWordField (Arg0, 0x04, AEBX)
                CreateDWordField (Arg0, 0x08, AECX)
                CreateDWordField (Arg0, 0x0C, AEDX)
                Store (0x80000001, PINX)
                Store (AECX, PAR0)
                Store (AEAX, PAR1)
                Store (AEDX, PAR2)
                ISMI (0x90)
                Release (MPAR)
            }
            Return (Ones)
        }
        Method (PRID, 1, Serialized)
        {
            If (LEqual (Acquire (MPAR, 0xFFFF), Zero))
            {
                Store (0x80000002, PINX)
                Store (Arg0, PAR0)
                ISMI (0x90)
                Store (PAR1, REAX)
                Store (PAR2, REDX)
                Release (MPAR)
                Return (ARBF)
            }
            Return (Ones)
        }
        Method (GPRE, 1, Serialized)
        {
            Store (Arg0, PAR0)
            Store (0x80000005, PINX)
            ISMI (0x90)
            Return (PAR0)
        }
        Method (GNVS, 1, Serialized)
        {
            Store (Arg0, PAR0)
            Store (0x80000003, PINX)
            ISMI (0x90)
            Return (PAR1)
        }
        Method (SNVS, 2, Serialized)
        {
            Store (Arg0, PAR0)
            Store (Arg1, PAR1)
            Store (0x80000004, PINX)
            ISMI (0x90)
        }
        Method (SARM, 1, Serialized)
        {
            If (LAnd (LGreater (Arg0, 0x03), LLess (Arg0, 0x06)))
            {
                ISMI (0x92)
            }
        }
        Method (GAMM, 0, Serialized)
        {
            ISMI (0x91)
        }
        Method (SAMM, 0, Serialized)
        {
            ISMI (0x92)
        }
    }
    If (OSCF)
    {
        Scope (_SB.PCI0)
        {
            Method (_OSC, 4, NotSerialized)
            {
                Name (SUPP, Zero)
                Name (CTRL, Zero)
                If (LEqual (Arg0, Buffer (0x10)
                        {
                            /* 0000 */   0x5B, 0x4D, 0xDB, 0x33, 0xF7, 0x1F, 0x1C, 0x40,
                            /* 0008 */   0x96, 0x57, 0x74, 0x41, 0xC0, 0x3D, 0xD7, 0x66
                        }))
                {
                    CreateDWordField (Arg3, Zero, CDW1)
                    CreateDWordField (Arg3, 0x04, CDW2)
                    CreateDWordField (Arg3, 0x08, CDW3)
                    Store (CDW2, SUPP)
                    Store (CDW3, CTRL)
                    If (LNotEqual (And (SUPP, 0x16), 0x16))
                    {
                        And (CTRL, 0x1E)
                    }
                    If (LNot (PEHP))
                    {
                        And (CTRL, 0x1E, CTRL)
                    }
                    And (CTRL, 0x1D, CTRL)
                    If (Not (And (CDW1, One)))
                    {
                        If (And (CTRL, One)) {}
                        If (And (CTRL, 0x04))
                        {
                            Store (One, EPNM)
                        }
                        Else
                        {
                            Store (Zero, EPNM)
                        }
                        If (And (CTRL, 0x10)) {}
                    }
                    If (LNotEqual (Arg1, One))
                    {
                        Or (CDW1, 0x08, CDW1)
                    }
                    If (LNotEqual (CDW3, CTRL))
                    {
                        Or (CDW1, 0x10, CDW1)
                    }
                    Store (CTRL, CDW3)
                    Return (Arg3)
                }
                Else
                {
                    Or (CDW1, 0x04, CDW1)
                    Return (Arg3)
                }
            }
        }
    }
    Scope (_SB.PCI0.SBRG)
    {
        Method (S3RS, 1, NotSerialized)
        {
            If (LEqual (Arg0, 0x03))
            {
                WBYT (0x80, 0x27, Zero)
            }
        }
    }
    Scope (_GPE)
    {
        Method (_L05, 0, NotSerialized)
        {
            \AMW0.AMWN (0xA0020000)
        }
    }
    Method (WBYT, 3, NotSerialized)
    {
        And (Arg0, 0xFE, Arg0)
        ASCM (Arg0, Arg1, Arg2, 0x08)
    }
    Method (W2YT, 3, NotSerialized)
    {
        And (Arg0, 0xFE, Arg0)
        A2CM (Arg0, Arg1, Arg2, 0x08)
    }
    Method (RBYT, 2, NotSerialized)
    {
        Or (Arg0, One, Arg0)
        Return (And (ASCM (Arg0, Arg1, Zero, 0x08), 0xFF))
    }
    Method (R2YT, 2, NotSerialized)
    {
        Or (Arg0, One, Arg0)
        Return (And (A2CM (Arg0, Arg1, Zero, 0x08), 0xFF))
    }
    OperationRegion (SMRG, SystemIO, SMB0, 0x30)
    Field (SMRG, ByteAcc, NoLock, Preserve)
    {
        HSTS,   8, 
        SSTS,   8, 
        HSTC,   8, 
        HCMD,   8, 
        HADR,   8, 
        HDT0,   8, 
        HDT1,   8, 
        BLKD,   8, 
        Offset (0x20), 
        H2TS,   8, 
        S2TS,   8, 
        H2TC,   8, 
        H2MD,   8, 
        H2DR,   8, 
        H2T0,   8, 
        H2T1,   8
    }
    Method (ASCM, 4, Serialized)
    {
        Store (0x05, Local0)
        While (Decrement (Local0))
        {
            Store (0x1E, HSTS)
            Stall (0x0A)
            While (LAnd (And (HSTS, One), One))
            {
                Store (0x1E, HSTS)
                Stall (0x0A)
            }
            Store (Arg1, HCMD)
            Stall (0x0A)
            Store (Arg0, HADR)
            Stall (0x0A)
            And (Arg0, One, Local2)
            Store (Arg3, HSTC)
            Stall (0x0A)
            Store (Arg2, HDT0)
            Stall (0x0A)
            Store (0x1E, HSTS)
            Stall (0x0A)
            While (LAnd (And (HSTS, One), One))
            {
                Store (0x1E, HSTS)
                Stall (0x0A)
            }
            Or (HSTC, 0x40, HSTC)
            Stall (0x0A)
            Store (0xFFFF, Local1)
            While (LEqual (And (HSTS, One), One))
            {
                Stall (0x14)
            }
            If (And (HSTS, 0x1C))
            {
                Return (Ones)
            }
            If (Local2)
            {
                Return (HDT0)
            }
        }
        Return (Ones)
    }
    Method (A2CM, 4, Serialized)
    {
        Store (0x05, Local0)
        While (Decrement (Local0))
        {
            Store (0xFFFF, Local1)
            While (LAnd (And (H2TS, One), Decrement (Local1)))
            {
                Stall (0x0A)
            }
            Store (0x1E, H2TS)
            Stall (0x0A)
            Store (Arg1, H2MD)
            Stall (0x0A)
            Store (Arg0, H2DR)
            Stall (0x0A)
            Store (Arg3, H2TC)
            Stall (0x0A)
            Store (Arg2, H2T0)
            Stall (0x0A)
            Or (H2TC, 0x40, H2TC)
            Stall (0x0A)
            Store (0xFFFF, Local1)
            While (Decrement (Local1))
            {
                If (LEqual (And (H2TS, 0x7F), Zero))
                {
                    Stall (0x0A)
                }
                Else
                {
                    Store (One, Local1)
                }
            }
            Store (0xFFFF, Local1)
            While (Decrement (Local1))
            {
                If (LAnd (And (H2TS, One), One))
                {
                    Stall (0x0A)
                }
                Else
                {
                    Store (One, Local1)
                }
            }
            If (And (H2TS, 0x1C))
            {
                Return (Ones)
            }
            If (And (Arg0, One))
            {
                Return (H2T0)
            }
            If (LAnd (H2TS, 0x02))
            {
                Store (One, Local0)
            }
        }
        Return (Ones)
    }
    Name (_S0, Package (0x04)
    {
        Zero, 
        Zero, 
        Zero, 
        Zero
    })
    If (SS1)
    {
        Name (_S1, Package (0x04)
        {
            One, 
            Zero, 
            Zero, 
            Zero
        })
    }
    If (SS3)
    {
        Name (_S3, Package (0x04)
        {
            0x03, 
            Zero, 
            Zero, 
            Zero
        })
    }
    If (SS4)
    {
        Name (_S4, Package (0x04)
        {
            0x04, 
            Zero, 
            Zero, 
            Zero
        })
    }
    Name (_S5, Package (0x04)
    {
        0x05, 
        Zero, 
        Zero, 
        Zero
    })
    Method (PTS, 1, NotSerialized)
    {
        If (Arg0)
        {
            SPTS (Arg0)
            \_SB.PCI0.SBRG.IPTS (Arg0)
            \_SB.SARM (Arg0)
            \_SB.PCI0.NPTS (Arg0)
            \_SB.PCI0.SBRG.SIOS (Arg0)
        }
    }
    Method (WAK, 1, NotSerialized)
    {
        SWAK (Arg0)
        \_SB.PCI0.NWAK (Arg0)
        \_SB.PCI0.SBRG.S3RS (Arg0)
        \_SB.PCI0.SBRG.SIOW (Arg0)
    }
    Method (DTGP, 5, NotSerialized)
    {
        If (LEqual (Arg0, Buffer (0x10)
                {
                    /* 0000 */    0xC6, 0xB7, 0xB5, 0xA0, 0x18, 0x13, 0x1C, 0x44, 
                    /* 0008 */    0xB0, 0xC9, 0xFE, 0x69, 0x5E, 0xAF, 0x94, 0x9B
                }))
        {
            If (LEqual (Arg1, One))
            {
                If (LEqual (Arg2, Zero))
                {
                    Store (Buffer (One)
                        {
                            0x03
                        }, Arg4)
                    Return (One)
                }
                If (LEqual (Arg2, One))
                {
                    Return (One)
                }
            }
        }
        Store (Buffer (One)
            {
                0x00
            }, Arg4)
        Return (Zero)
    }
        Method (PINI, 0, NotSerialized)
        {
        }
}
